C     Last change:  DRM  30 Jul 2003    3:43 pm
C******** ********* ********* ********* ********* ********* ********* *
C
C		 		SMARTS MODEL, Version 2.9.2
C
C**********************************************************************
C
C CALCULATES CLEAR SKY SPECTRAL SOLAR IRRADIANCES FROM 280 TO 4000 nm.
C
C  Research code written by C. GUEYMARD
C	Version 2.0: November 1995
c	Version 2.9: February 2002
c	Version 2.9.1: May 2002
C             Version 2.9.2: July 2002
C
C***
C***		Consult the 'HISTORY.TXT' file and the 'New Features'
C***		Section of the User's Manual for details about the
C***		changes that occurred in the successive versions.
C***		Some input cards may have changed content!
C***
C***		Consult the User's Manual for details and explanations
C***		about the INPUT data cards and OUTPUT files!
C
C
	Program SMARTS
c	
	Double Precision TO3,TAUZ3,DIR,DIF0,DIF,GLOB,GLOBS,DIRH,FHTO,rocb
	Double Precision DIRS,DIFS,DIREXP,DIFEXP,DGRND,HT,DRAY,TH2O,TH2OP
	Double Precision TABS,TDIR,DAER,PFG,PFD,PFB,GAMOZ,WPHT,GRNS,TTP
	Double Precision DIRWL,SUMBN,SUMBX,SUMD,SUMDX,SUMBS,Difccs,Glob0
	Double Precision BNORM(2002),GLOBH(2002),GLOBT(2002),DIRX(2002)
	Double Precision Tcoro3,tz3,AO4,TO4,TO4P
	Double Precision Julian,dec,Longit,Latit,phi2,Zenit,zr,zx,Azim,azr
	Double Precision TO2,TO2P,TCO2,TCO2P,NLosch,Bw,Bp,Prod,cosaz,AbO4
	Double Precision Tmixd,TmixdP,Trace,TraceP,Phot,Rhor,Rhos,Roro,AO3
	Double Precision AmO2,AmCO2,tauo2,tauco2
	Double Precision AmH2O,wAmw,wAmp,tauw,Bmw,Bmwp,ww02

	INTEGER IOUT(34),CIEYr,year,day,DayoYr
	REAL RB0(4),RB1(4),RB2(4),RB3(4),RDHB(4),limit,Xout(24)
	REAL O3REF(11),UNREF(11),VL(425),ETSPCT(2002),Output(32)
	Real Wvla1(2002),Albdo1(2002),Wvla2(2002),Albdo2(2002)
	REAL C1(4),C2(4),C3(4),C4(4),C5(4),D1(4),D2(4),D3(4),D4(4),D5(4)
	REAL BP00(4),BP01(4)
	REAL BP02(4),BP10(4),BP11(4),BP12(4),BP20(4),BP21(4),BP22(4)
	REAL BP30(4),BP31(4),BP32(4),BQ00(4),BQ01(4),BQ02(4)
	REAL BQ10(4),BQ11(4),BQ12(4),BQ20(4),BQ21(4),BQ22(4)
	REAL BQ0(7),BQ1(7),BQ2(7),AG41(4),AG42(4),WV(2002)
	REAL BP0(7),BP1(7),BP2(7),BP3(7),AG0(7),AG1(7),AG2(7),AG3(7)
	REAL AG4(7),AG00(4),AG01(4),AG02(4),AG10(4),AG11(4),AG12(4)
	REAL AG20(4),AG21(4),AG22(4),AG30(4),AG31(4),AG32(4),AG40(4) 
	Real Bmx(2),Bmwx(2),intvl,KW,Vi(5)
	REAL DECLI(12)/-20.71,-12.81,-1.8,9.77,18.83,23.07,21.16,13.65,
     1   2.89,-8.72,-18.37,-22.99/
	REAL RSUN(12)/1.032,1.025,1.011,.994,.978,.969,.967,.975,.99,
     1   1.007,1.022,1.031/
c
	CHARACTER*64 AEROS, Spctrm, Comnt		
	Character*48 dummy, smart
	Character*24 Filen1, Filen2, Lambr1, Lambr2
	CHARACTER*24 FileIn,FileOut,FileExt,FileScn
	CHARACTER*24 Load, Usernm
	Character*18 Out(32)
	Character*12 Filter
	CHARACTER*6 SEASON, Area
	CHARACTER*4 Atmos, YesNo

	COMMON /SOLAR1/ WV,WLMN,wlmx,WV1,WV2
	COMMON /SOLAR2/ BNORM,GLOBH,GLOBT,DIRX,ETSPCT
	Common /Solar3/ Dir,Aeros,Tauas,Taurl,Rhox,rpd,pi,pix4,AmR,WVL,
     2   wvln,nx,Znr,va,vb,RH
      Common /Number/ NLosch
     
	DATA O3REF/.34379,.33195,.37707,.34512,.37592,.27761,.3,.28,.33,
     1 .38,.34379/
	DATA UNREF/2.0443E-4,2.1841E-4,1.9867E-4,2.1569E-4,1.8678E-4,
     1 2.1119E-4,2E-4,1E-4,2E-4,1E-4,2.0443E-4/
	DATA A0/-0.897/,A1/4.448/,A2/-2.77/,A3/0.312/,RD0/0.408/
	DATA RB0/-3.364,3.96,-1.909,0./
	DATA RB1/-12.962,34.601,-48.784,27.511/
	DATA RB2/9.164,-18.876,23.776,-13.014/
	DATA RB3/-.217,-.805,.318,0./
	DATA RDHB/-.323,.384,-.17,0./
	DATA C1/.52826,.32525,.12804,.64122/
	DATA C2/33.2323,23.761,.40474,28.194/
	DATA C3/8.497,-1.3983,-.24856,8.1312/
	DATA C4/-5.9992,0.,0.,-5.826/
	DATA C5/37.956,26.723,-.39272,29.937/
	DATA D1/.83149,.88686,.066702,1.6056/
	DATA D2/84.276,94.714,.97504,203.96/
	DATA D3/-3.2441,-31.086,-.40251,95.007/
	DATA D4/3.8312,18.525,0.,-60.407/
	DATA D5/58.119,70.057,.021733,99.825/
	DATA BP0/0.,0.,0.,0.,.84372,.64886,.96635/
	DATA BP1/0.,0.,0.,0.,.30206,.13465,.073464/
	DATA BP2/0.,0.,0.,0.,-.47838,-.30166,-.071847/
	DATA BP3/0.,0.,0.,0.,.15647,.083393,.019774/
	DATA BQ0/0.,0.,0.,0.,1.2853,2.9784,2.0006/
	DATA BQ1/0.,0.,0.,0.,1.486,.61494,7.111/
	DATA BQ2/0.,0.,0.,0.,2.8357,3.3122,3.0136/
	DATA AG0/0.,0.,0.,0.,.75141,.66851,.77876/
	DATA AG1/0.,0.,0.,0.,-.35648,-.20657,-.13625/
	DATA AG2/0.,0.,0.,0.,.29982,.1468,.16092/
	DATA AG3/0.,0.,0.,0.,-.081346,-.040565,-.056749/
	DATA AG4/0.,0.,0.,0.,7.3038E-3,3.8811E-3,6.1178E-3/
	DATA BP00/1.0151,.84946,.94016,.99926/
	DATA BP01/-6.0574E-3,-9.7903E-3,-3.5957E-4,-5.0201E-3/
	DATA BP02/5.5945E-5,1.0266E-4,9.8774E-6,4.8169E-5/
	DATA BP10/-1.2901E-1,-2.0852E-1,1.2843E-1,-5.5311E-2/
	DATA BP11/2.1565E-2,1.2935E-2,1.2117E-3,1.8072E-2/
	DATA BP12/-1.95E-4,-9.4275E-5,-2.7557E-5,-1.693E-4/
	DATA BP20/2.0622E-1,3.9371E-1,-1.4612E-1,9.0412E-2/
	DATA BP21/-3.1109E-2,-2.3536E-2,-8.5631E-4,-2.3949E-2/
	DATA BP22/2.8096E-4,1.8413E-4,2.7298E-5,2.2335E-4/
	DATA BP30/-8.1528E-2,-1.3342E-1,3.9982E-2,-3.9868E-2/
	DATA BP31/1.0582E-2,7.301E-3,3.7258E-4,7.5484E-3/
	DATA BP32/-9.5007E-5,-5.7236E-5,-9.5415E-6,-6.9475E-5/
	DATA BQ00/-3.0306,7.5308,-3.7748,-4.4981/
	DATA BQ01/.12324,-.15526,.13631,.17798/
	DATA BQ02/-6.408E-4,1.0762E-3,-7.6824E-4,-9.9386E-4/
	DATA BQ10/1.0949,-.88621,1.5129,-5.0756/
	DATA BQ11/5.4308E-3,-7.2508E-2,1.5867E-2,.13536/
	DATA BQ12/1.7654E-5,9.8766E-4,-1.2999E-4,-6.7061E-4/
	DATA BQ20/2.5572,2.2092,2.8725,6.6072/
	DATA BQ21/7.2117E-3,2.9849E-2,2.6098E-3,-8.1503E-2/
	DATA BQ22/-2.5712E-5,-2.2029E-4,-9.2133E-6,4.5423E-4/
	DATA AG00/.75831,.65473,.77681,.77544/
	DATA AG01/9.5376E-4,6.0975E-3,-2.7558E-3,-3.1632E-3/
	DATA AG02/-2.3126E-6,-4.3907E-5,3.635E-5,3.577E-5/
	DATA AG10/6.5007E-2,1.0582E-2,-3.07E-1,-2.3927E-3/
	DATA AG11/-1.9238E-2,-2.0473E-2,5.5554E-3,-3.8837E-3/
	DATA AG12/1.6785E-4,1.9499E-4,-4.014E-5,2.8519E-5/
	DATA AG20/-2.5092E-2,7.2283E-2,1.1744E-1,-9.6464E-3/
	DATA AG21/1.5397E-2,1.3209E-2,3.7471E-4,5.8684E-4/
	DATA AG22/-1.3813E-4,-1.3393E-4,-1.5242E-6,-4.3942E-6/
	DATA AG30/-4.7607E-4,-3.3056E-2,-7.4695E-3,0./
	DATA AG31/-4.0963E-3,-3.0744E-3,-1.0596E-3,0./
	DATA AG32/3.6814E-5,3.191E-5,6.5979E-6,0./
	DATA AG40/7.4163E-4,3.6485E-3,-1.381E-3,0./
	DATA AG41/3.5332E-4,2.4708E-4,1.7037E-4,0./
	DATA AG42/-3.146E-6,-2.544E-6,-1.0431E-6,0./
	Data Vi/.036525,8.375,35.801,8.2479,-.31302/

C
	PHOT=5.0340361D+14
	pi=3.14159265
	pi2=pi/2.
	pix4=pi*4.
	RPD=pi/180.
	NLosch=2.68719D19
	RANGE1=1./340.85
	epsiln=1e-3
	epsilm=1e-6
	FileIn='SMARTS2.INP'
	FileOut='SMARTS2.OUT'
	FileExt='SMARTS2.EXT'
	FileScn='SMARTS2.SCN'
C
C
C	Files (some with User-defined filenames)
c
c----------------------------------------------------------------------
c
c	Remove the whole section below (25 lines of code), 
c	then recompile, if you want a pure batch mode!!!
c
c**********************************************************************
c
C	smart='Welcome to SMARTS2, version 2.9.2!'
C 	write(6,314) smart
C314	format(/,35('*'),/,1x,a48,/,35('*'),//,' SMARTS2> ',
C    1 'Use batch mode?'/,' [If YES, this window will close',
C    2 ' and execution',/,' will be using the default input file',
C    3 ' SMARTS2.INP]',/,' (Y/N) -->')
C     Read(5,318) YesNo
C	If(YesNo.eq.'Y'.or.YesNo.eq.'y')goto 313
C333	Write(6,315)
C315	Format(' SMARTS2> Generic name for the input file (without .INP;'
C    2 ,' 24 characters max.)? -->')
C	Read(5,316) Usernm
C316	Format(A24)
C	Iname=Index(Usernm,' ') - 1
CFileIn=Usernm(1:Iname)//'.INP'
CFileOut=Usernm(1:Iname)//'.OUT'
CFileExt=Usernm(1:Iname)//'.EXT'
C	Write(6,317) FILEIN,FILEOUT,FILEEXT
C317	Format(' SMARTS2> You chose the following filenames:',/,
C   2 '  Input:  ',A24,/,'  Output: ',A24,/,'  Spreadsheet-ready:  ',
C     3 A24,//,' SMARTS2> Is this OK? (Y/N) -->')
C     	Read(5,318) YesNo
C 318	Format(a1)
C 	If(YesNo.eq.'N'.or.YesNo.eq.'n')goto 333
C 313	continue
c
c**********************************************************************
c
c
	OPEN (UNIT=14,FILE=FileIn,STATUS='OLD')
	OPEN (UNIT=16,FILE=FileOut,STATUS='NEW')
	OPEN (UNIT=22,FILE='Abs_O2.dat',STATUS='OLD')
	OPEN (UNIT=25,FILE='Abs_O4.dat',STATUS='OLD')
	OPEN (UNIT=26,FILE='Abs_N2.dat',STATUS='OLD')
	OPEN (UNIT=27,FILE='Abs_N2O.dat',STATUS='OLD')
	OPEN (UNIT=28,FILE='Abs_NO.dat',STATUS='OLD')
	OPEN (UNIT=29,FILE='Abs_NO2.dat',STATUS='OLD')
	OPEN (UNIT=30,FILE='Abs_NO3.dat',STATUS='OLD')
	OPEN (UNIT=31,FILE='Abs_HNO3.dat',STATUS='OLD')
	OPEN (UNIT=32,FILE='Abs_SO2U.dat',STATUS='OLD')
	OPEN (UNIT=33,FILE='Abs_SO2I.dat',STATUS='OLD')
	OPEN (UNIT=34,FILE='Abs_CO.dat',STATUS='OLD')
	OPEN (UNIT=35,FILE='Abs_CO2.dat',STATUS='OLD')
	OPEN (UNIT=36,FILE='Abs_CH4.dat',STATUS='OLD')
	OPEN (UNIT=37,FILE='Abs_NH3.dat',STATUS='OLD')
	OPEN (UNIT=38,FILE='Abs_BrO.dat',STATUS='OLD')
	OPEN (UNIT=39,FILE='Abs_CH2O.dat',STATUS='OLD')
	OPEN (UNIT=40,FILE='Abs_HNO2.dat',STATUS='OLD')
	OPEN (UNIT=41,FILE='Abs_ClNO.dat',STATUS='OLD')
	read(22,*)dummy
	read(25,*)dummy
	read(26,*)dummy
	read(27,*)dummy
	read(28,*)dummy
	read(29,*)dummy
	read(30,*)dummy
	read(31,*)dummy
	read(32,*)dummy
	read(33,*)dummy
	read(34,*)dummy
	read(35,*)dummy
	read(36,*)dummy
	read(37,*)dummy
	read(38,*)dummy
	read(39,*)dummy
	read(40,*)dummy
	read(41,*)dummy
C
C***	CARD 1
C
	READ(14,*) COMNT
C
C***	CARD 2
C
	READ(14,*) ISPR
	IF(ISPR.EQ.1)GOTO 301
	IF(ISPR.EQ.2)GOTO 302
C
C***	CARD 2a if ISPR=0
C
	READ(14,*) SPR
C
C	APPROXIMATE FUNCTION SPR=F(altit,Latit) ACCORDING TO GUEYMARD 
C		(SOLAR ENERGY 1993)
C
	XP=SPR/1013.25
	DTA=.014321-.00544*log(XP)
	Altit=(DTA**.5-.11963)/.00272
	IF(Altit.LE.0.)Altit=0.
	GOTO 300
 301	CONTINUE
C
C***	CARD 2a if ISPR=1
C
 	READ(14,*)SPR,Altit
 	GOTO 300
 302	CONTINUE
C
C***	CARD 2a if ISPR=2
C
 	READ(14,*)Latit,Altit
	PCOR=1.
	IF(Latit.EQ.45.0)GOTO 303
	PHI2=Latit*Latit
	PCOR1=.993+2.0783E-04*Latit-1.1589E-06*PHI2
	PCOR2=8.855E-03-1.5236E-04*Latit-9.2907E-07*PHI2
	PCOR=PCOR1+Altit*PCOR2
 303	SPR=1013.25*PCOR*EXP(.00177-.11963*Altit-.00136*Altit*Altit)
 300	CONTINUE
 	pp0=SPR/1013.25
	qp=1.-pp0
	Alt2=Altit*Altit
C
C***	CARD 3
C
	READ(14,*) iAtmos
C
C***	CARD 3a
C
	IF(iAtmos.EQ.0)READ(14,*)TAIR,RH,SEASON,TDAY
	IF(iAtmos.EQ.1)READ(14,*)Atmos
C
C***	CARD 4
C
	READ(14,*) IH2O
C 	
 311	IF(iAtmos.NE.1)GOTO 320
	IF(Atmos.EQ.'USSA')IREF=1
	IF(Atmos.EQ.'MLS')IREF=2
	IF(Atmos.EQ.'MLW')IREF=3
	IF(Atmos.EQ.'SAS')IREF=4
	IF(Atmos.EQ.'SAW')IREF=5
	IF(Atmos.EQ.'TRL')IREF=6
	IF(Atmos.EQ.'STS')IREF=7
	IF(Atmos.EQ.'STW')IREF=8
	IF(Atmos.EQ.'AS')IREF=9
	IF(Atmos.EQ.'AW')IREF=10
C
C	AVERAGE STRATOSPHERIC TEMPERATURE AND REFERENCE ATMOSPHERIC
C		CONDITIONS
C
	CALL RefAtm(PREF,TK,TGRND,TEMPA,RH,WREF,Altit,Iref) 
	IF(ISPR.EQ.2)SPR=PREF
	TAIR=TK-273.15
	TT0=Tk/273.15
	GOTO 321
C
 320	Atmos='USER'
	IREF=11
	wref=1.4164
	TK=TAIR+273.15
	TT0=Tk/273.15
 	TGRND=TDAY+273.15
 	IF(Altit.EQ.0.0)GOTO 324
	AT0=MIN(49.42,(70.24-23.428*Altit+2.523*ALT2))
	AT1=MIN(.1878,(.26073-.082424*Altit+.009098*ALT2))
	TGRND=(TGRND-AT0)/(1.-AT1)
 324	CONTINUE
	TEMPA=332.41-.34467*TGRND
	IF(SEASON.EQ.'WINTER')TEMPA=142.68+.28498*TGRND
 321	w=wref
 	IF(IH2O.eq.1.and.iAtmos.ne.1)
     1 CALL RefAtm(dum0,dum1,dum2,dum3,dum4,W,Altit,1)
	IF(IH2O.NE.2)GOTO 319
C
C	SATURATION VAPOR PRESSURE ACCORDING TO GUEYMARD (JAM 1993)
C
c	TK=TAIR+273.15
	TK1=TK/100.
	EVS=EXP(22.329699-49.140396/TK1-10.921853/TK1/TK1-.39015156*TK1)
	EV=EVS*RH/100.
C
C	W=f(T,RH) USING EMPIRICAL MODEL OF GUEYMARD (SOLAR ENERGY 1994)
C
	ROV=216.7*EV/TK
 	TT=1.+(TAIR/273.15)
	HV=.4976+1.5265*TT+EXP(13.6897*TT-14.9188*TT**3)
	W=.1*HV*ROV
 319	IF(IH2O.NE.0)GOTO 328
C
C***	CARD 4a if IH2O=0
C
	READ(14,*)W
C
 328	CONTINUE
 	if(w.le.12.)goto 327
	write(16,1027)w
 1027	format(' The value selected or calculated for precipitable water'
     1 ,', w, is ',f10.3,', which is above the allowed maximum value'
     2 ,' of 12 cm. RUN ABORTED!')
      goto 914	
 327	continue
 	if(w.le.0.)goto 776
	OPEN (UNIT=21,FILE='Abs_H2O.dat',STATUS='OLD')
	read(21,*)dummy
 776	continue
	TEMPO=TEMPA
	TEMPN=TEMPA
C
C***	CARD 5
C
	IALT=0
 329	READ(14,*)IO3
 	IF(IO3.EQ.1)GOTO 331
C
C***	CARD 5a if IO3=0
C
	READ(14,*) IALT,AbO3
	goto 332
 331	AbO3=O3REF(IREF)
 332	if(AbO3.le.0.)goto 335
 	OPEN (UNIT=23,FILE='Abs_O3UV.dat',STATUS='OLD')
	OPEN (UNIT=24,FILE='Abs_O3IR.dat',STATUS='OLD')
	read(23,*)dummy
	read(24,*)dummy
 335	THICK=1.
C
C	OZONE TOTAL COLUMN CORRECTION FITTED FROM REF. ATM. (VALID UP TO
C		AT LEAST 10 KM)
C
	IF(IALT.EQ.1)THICK=1.-.00898*Altit
 	UOC=AbO3*THICK
	ApO3=0.
C
C***	CARD 6 - Modified in 2.9! Now refers to gaseous pollution...
C
	Load='STANDARD'
c
 	READ(14,*)IGAS
	IF(IGAS.EQ.1)GOTO 340
C
C***	CARD 6a if 	IGAS=0 - Changed in 2.9! Now inputs gaseous overload
c	 in the lower 1-km pollution layer (in ppmv)
C
	READ(14,*)iLoad
	Load='USER-DEFINED'
	ApCH2O=-.003
	ApCH4=0.
	ApCO=-.1
	ApHNO2=-.00099
	ApHNO3=0.
      ApNO=0.
	ApNO2=0.
	ApNO3=-.00049
	ApO3=-.007
	ApSO2=0.
	if(iLoad.ne.1)goto 80
c
c	Default Pristine conditions
c
	Load='PRISTINE ATMOSPHERE'
	ApCH2O=-.003
	ApCH4=0.
	ApCO=-.1
	ApHNO2=-.00099
	ApHNO3=0.
      ApNO=0.
	ApNO2=0.
	ApNO3=-.00049
	ApO3=-.007
	ApSO2=0.
 80   if(iLoad.ne.2)goto 81
c
c	Default 'LIGHT POLLUTION' conditions
c
	Load='LIGHT POLLUTION'
	ApCH2O=.001
	ApCH4=.2
	ApCO=0.
	ApHNO2=.0005
	ApHNO3=.001
      ApNO=.075
	ApNO2=.005
	ApNO3=.00001
	ApO3=.023
	ApSO2=.01
 81	if(iLoad.ne.3)goto 82
c
c	Default 'MODERATE POLLUTION' conditions
c
	Load='MODERATE POLLUTION'
	ApCH2O=.007
	ApCH4=.3
	ApCO=.35
	ApHNO2=.002
	ApHNO3=.005
      ApNO=.2
	ApNO2=.02
	ApNO3=.00005
	ApO3=.053
	ApSO2=.05
 82	if(iLoad.ne.4)goto 83
c
c	Default 'SEVERE POLLUTION' conditions
c
	Load='SEVERE POLLUTION'
	ApCH2O=.01
	ApCH4=.4
	ApCO=9.9
	ApHNO2=.01
	ApHNO3=.012
      ApNO=.5
	ApNO2=.2
	ApNO3=.0002
	ApO3=.175
	ApSO2=.2
 83	continue
c
C***	CARD 6b - If iLoad = 0  --- New in 2.9
c
	if(iLoad.eq.0)Read(14,*)ApCH2O,ApCH4,ApCO,ApHNO2,ApHNO3,
     3 ApNO,ApNO2,ApNO3,ApO3,ApSO2
c
c	Conversion from ppmv to atm-cm
c
	ApCH2O=ApCH2O*.1
	ApCH4=ApCH4*.1
	ApCO=ApCO*.1
	ApHNO2=ApHNO2*.1
	ApHNO3=.012*.1
      ApNO=ApNO*.1
	ApNO2=ApNO2*.1
	ApNO3=ApNO3*.1
	ApO3=ApO3*.1
	ApSO2=ApSO2*.1
 340	CONTINUE
 	UN=UNREF(IREF)
	UNC=UN*(1.-.00898*Altit)
C
C
C***	CARD 7 - Changed in 2.9!! Input CO2 concentration (ppmv)
C
	READ(14,*) qCO2
c
C***	CARD 7a - Changed in 2.9!! Choose ET spectrum
C
	READ(14,*)Ispctr
	if(ispctr.eq.1)OPEN (UNIT=15,FILE='Spctrm_1.dat',STATUS='OLD')
	if(ispctr.eq.2)OPEN (UNIT=15,FILE='Spctrm_2.dat',STATUS='OLD')
	if(ispctr.eq.3)OPEN (UNIT=15,FILE='Spctrm_3.dat',STATUS='OLD')
	if(ispctr.eq.4)OPEN (UNIT=15,FILE='Spctrm_4.dat',STATUS='OLD')
	if(ispctr.eq.5)OPEN (UNIT=15,FILE='Spctrm_5.dat',STATUS='OLD')
	if(ispctr.eq.6)OPEN (UNIT=15,FILE='Spctrm_6.dat',STATUS='OLD')
	if(ispctr.eq.7)OPEN (UNIT=15,FILE='Spctrm_7.dat',STATUS='OLD')
c
C
C***	CARD 8
C
	READ(14,*) AEROS
	IF(AEROS.NE.'USER')GOTO 350
C
C***	CARD 8a if AEROS='USER'
C
	READ(14,*) ALPHA1,ALPHA2,OMEGL,GG
	IAER=0
	GOTO 355
C
C	AEROSOL CHARACTERISTICS
C
 350	CONTINUE
	IF(AEROS.EQ.'S&F_RURAL')IAER=1
	IF(AEROS.EQ.'S&F_URBAN')IAER=2
	IF(AEROS.EQ.'S&F_MARIT')IAER=3	
	IF(AEROS.EQ.'S&F_TROPO')IAER=4
	IF(AEROS.EQ.'SRA_CONTL')IAER=5
	IF(AEROS.EQ.'SRA_URBAN')IAER=6
	IF(AEROS.EQ.'SRA_MARIT')IAER=7
	IF(AEROS.EQ.'B&D_C1')IAER=8
	IF(AEROS.EQ.'B&D_C')IAER=9
C	
	IF(IAER.NE.8.AND.IAER.NE.9)GOTO 358
	ALPHA1=-.311
	ALPHA2=.265
	GOTO 355
 358 	CONTINUE
 	IF(IAER.NE.5)GOTO 360
	ALPHA1=.94
	ALPHA2=1.335
	GOTO 355
 360	IF(IAER.NE.6)GOTO 362
 	ALPHA1=1.047
	ALPHA2=1.472
	GOTO 355
 362	IF(IAER.NE.7)GOTO 364
 	ALPHA1=0.283
	ALPHA2=0.265
	GOTO 355
 364	CONTINUE
	IF(RH.GT.100.)RH=50.
c
c	Angstrom's alpha for Shettle & Fenn aerosols (modified in 2.9)
c
	XRH=COS(0.9*RH*RPD)
	xrh2=xrh*xrh
	xrh3=xrh2*xrh
	ALPHA1=(C1(IAER)+C2(IAER)*XRH+C3(IAER)*XRH2+C4(iaer)*xrh3)/
     1 (1.+C5(IAER)*XRH)
	ALPHA2=(D1(IAER)+D2(IAER)*XRH+D3(IAER)*XRH2+D4(iaer)*xrh3)/
     1 (1.+D5(IAER)*XRH)
    	RHC=MAX(50.,RH)
	RHC2=RHC*RHC
	IF(IAER.GT.4)GOTO 355
C
C	COEFFICIENTS FOR OMEGL (SINGLE SCATTERING ALBEDO)
C
	BP0(IAER)=BP00(IAER)+BP01(IAER)*RHC+BP02(IAER)*RHC2
	BP1(IAER)=BP10(IAER)+BP11(IAER)*RHC+BP12(IAER)*RHC2
	BP2(IAER)=BP20(IAER)+BP21(IAER)*RHC+BP22(IAER)*RHC2
	BP3(IAER)=BP30(IAER)+BP31(IAER)*RHC+BP32(IAER)*RHC2
	BQ0(IAER)=BQ00(IAER)+BQ01(IAER)*RHC+BQ02(IAER)*RHC2
	BQ1(IAER)=EXP(BQ10(IAER)+BQ11(IAER)*RHC+BQ12(IAER)*RHC2)
	BQ2(IAER)=BQ20(IAER)+BQ21(IAER)*RHC+BQ22(IAER)*RHC2
C
C	COEFFICIENTS FOR GG (ASYMMETRY FACTOR)
C
	AG0(IAER)=AG00(IAER)+AG01(IAER)*RHC+AG02(IAER)*RHC2
	AG1(IAER)=AG10(IAER)+AG11(IAER)*RHC+AG12(IAER)*RHC2
	AG2(IAER)=AG20(IAER)+AG21(IAER)*RHC+AG22(IAER)*RHC2
	AG3(IAER)=AG30(IAER)+AG31(IAER)*RHC+AG32(IAER)*RHC2
	AG4(IAER)=AG40(IAER)+AG41(IAER)*RHC+AG42(IAER)*RHC2
C
C***	CARD 9
C
 355	READ(14,*) ITURB
      ALPHA=(ALPHA1+ALPHA2)/2.
C
C	SELECT THE APPROPRIATE TURBIDITY INPUT
C
     	IF(ITURB.EQ.1)  GOTO 351
	IF(ITURB.EQ.2)  GOTO 352
	IF(ITURB.EQ.3)  GOTO 353
	IF(ITURB.EQ.4)  GOTO 354
C
C***	CARD 9a if ITURB=0
C
	READ(14,*)TAU5
	BETA=(0.5**ALPHA2)*TAU5
	GOTO 359
C
C***	CARD 9a if ITURB=1
C
 351	READ(14,*) BETA
 	TAU5=BETA/(0.5**ALPHA2)
	GOTO 359
 352	CONTINUE
C
C***	CARD 9a if ITURB=2
C
 	READ(14,*)BCHUEP
	TAU5=BCHUEP*2.302585
	BETA=(0.5**ALPHA2)*TAU5
 359	CONTINUE
C
C	FUNCTION RANGE=F(BETA,ALPHA) FROM NEW FIT - Modified in 2.9.2
C
	RANGE=999.
	Visi=764.9
	alpha3=alpha2
	If(IAer.ne.1.or.IRef.ne.1)goto 344
	If(beta.lt.0.001)goto 344
	bxm1=1./beta
	bxm0=7.041
	bxm2=bxm1*bxm1
	bxm3=bxm2*bxm1
      Alpha2=(-.17363+7.5209*bxm1+.40301*bxm2+
     1 .0071635*bxm3)/(1.+5.4671*bxm1+.32022*bxm2+.0037071*bxm3)
	If(bxm1.lt.bxm0)Alpha2=(1.2644+.24736*bxm1+.0011088*bxm2+
     1 4.5788E-5*bxm3)/(1.+.18678*bxm1)
      alpha3=(.95183+.3162*bxm1+.011199*bxm2+
     1 1.812E-5*bxm3)/(1.+.31656*bxm1+.011315*bxm2)
     	If(Iturb.eq.0.or.iturb.eq.2)beta=(0.5**ALPHA2)*TAU5
 344	continue
     	Tau550=Tau5/(1.1**alpha3)
	IF(Tau550.lt.0.0208)goto 357
	deltab=(Vi(4)*Tau550-Vi(2))**2-4.*(Vi(5)*Tau550-Vi(3))*
     1 (Tau550-Vi(1))
	XX=.5*(Vi(2)-Vi(4)*Tau550-(deltab**.5))/(Vi(5)*Tau550-Vi(3))
	Range=1./(XX+Range1)
	VISI=RANGE/1.306
	GOTO 357
 354	CONTINUE
C
C***	CARD 9a if ITURB=4
C
 	READ(14,*)VISI
	RANGE=1.306*VISI
	GOTO 356
 353	CONTINUE
C
C***	CARD 9a if ITURB=3
C
 	READ(14,*)RANGE
	VISI=RANGE/1.306
 356	CONTINUE
C
C	FIT BASED ON MODTRAN4 - Modified in 2.9.2
C
	If(Range.gt.0.)goto 399
	Write(16,192)
 192	Format(/,'***** FATAL ERROR!',/,' Input value for Visibility or',
     1 ' Meteorological Range is zero. Please specify a non-zero',
     2 ' value.'/,' RUN ABORTED ***')
      goto 914
 399  continue
	YVIS=(1./RANGE)-Range1
	Yvis2=Yvis*Yvis
	Tau550=(Vi(1)+Vi(2)*YVis+Vi(3)*Yvis2)/(1.+Vi(4)*Yvis+Vi(5)*Yvis2)
      IF(RANGE.GT.999.)Tau550=0.
     	If(IAer.eq.1.and.IRef.eq.1)Alpha2=(1.514+158.08*Yvis-2.5344*Yvis2)
     1 /(1.+123.31*Yvis)
      alpha3=(.95183+.3162*bxm1+.011199*bxm2+
     1 1.812E-5*bxm3)/(1.+.31656*bxm1+.011315*bxm2)
     	Tau5=Tau550*(1.1**alpha3)
	Beta=Tau5*(.5**ALPHA2)
 357	CONTINUE
 	IF(ITURB.NE.2)BCHUEP=TAU5/2.302585
C
	WRITE(16,194) COMNT,Atmos,AEROS
 194	FORMAT(/,'******************  SMARTS2, version 2.9.2  *********'
     % ,'**********',//,
     %' Simple Model of the Atmospheric Radiative Transfer of Sunshine'
     % ,/,20X,'Chris A. Gueymard, July 2002',//,
     $ 4X,'This model is documented in FSEC Report PF-270-95',/,
     2 ' and in a Solar Energy paper, vol. 71, No.5, 325-346 (2001)',
     3 //,' NOTE: These references describe v. 2.8 or earlier!!!',/,
     4 ' See the User''s Manual for details on recent changes...',//,
     %'************************************************************'
     % ,'***'//,6x,' Reference for this run: ',A64,//,64('-'),//,
     % '* ATMOSPHERE : ',A4,'   AEROSOL TYPE: ',A10,/)
	WRITE(16,100) SPR,Altit,RH,W,UOC,uoc*1000.,TAU5,Tau550,BETA,
     % BCHUEP,RANGE,VISI,ALPHA1,ALPHA2,ALPHA
 100	FORMAT('* INPUTS:'/,5x,'Pressure (mb) = ',F7.2,'   Altitude (km)', 
     % ' = ',F6.3,/,5X,'Relative Humidity (%) = ',F5.2,3X,
     $ 'Precipitable Water (cm) = ',F6.4,/,5x,'Ozone (atm-cm) = ',F6.4,
     1 ' or ',f5.1,' Dobson Units',/,3X,'AEROSOLS:  ','Optical Depth at'
     # ,' 500 nm = ',F6.4,'   Optical depth at 550 nm = ',f6.4,/,
     $ '     Angstrom''s Beta = ',F6.4,'   Schuepp''s'
     %,' B = ',F6.4,/,5x,'Visual Range (km) = ',F6.1,'   Visibility '
     %,'(km) = ',F6.1,/,5x,'Alpha1 = ',F6.4,'  Alpha2 = ',F6.4,
     & '   Mean Angstrom''s Alpha = ',F6.4)
	WRITE(16,134)TK,TGRND,TEMPO,TEMPN
 134	FORMAT('* TEMPERATURES:',/,5x,'Ground Level = ',F5.1,' K',/,5x,
     %'Sea Level = ',F5.1,' K',/,5x,'Ozone (effective) = ',F5.1,' K',/,
     % 5x,'NO2 (effective) = ',F5.1,' K',/)
C
C***	CARD 10
C
	Read(14,*) Ialbdx
	Rhox=0.2
	If(Ialbdx.lt.0)goto 383
	Call Albdat(Ialbdx,Nwal1,Filen1,Lambr1,Wvla1,Albdo1)
     	Goto 384
C
C***	CARD 10a
C
 383	READ(14,*) Rhox
 	
 384	Continue
C
C***	CARD 10b
C	
	Read(14,*)Itilt
	Tilt=0.
	Rhog=0.
	Wazim=0.
	If (Itilt.eq.0)Goto 389
C
C***	CARD 10c
C	
	Read(14,*)Ialbdg,TILT,WAZIM
c	
	Rhog=Rhox
	If(Ialbdg.ge.0)Goto 385
C
C***	CARD 10d
C	
	Read(14,*)Rhog
c	
	Goto 389
 385	Continue
 	Filen2=Filen1
	Lambr2=Lambr1
	If(Ialbdg.ne.Ialbdx)Call Albdat(Ialbdg,Nwal2,Filen2,
     2   Lambr2,Wvla2,Albdo2)
 389	Continue
C
C***	CARD 11 - Modified in 2.9
C
	READ(14,*)WLMN,WLMX,Suncor,SolarC
	
	If(Ialbdx.ge.0.and.Ialbdx.ne.2)
     2  Call Albchk(Nwal1,Filen1,Wvla1,Albdo1,.001*wlmn,.001*wlmx)
	If(Ialbdg.ge.0.and.Ialbdg.ne.2.and.Ialbdg.ne.Ialbdx.and.
     2 Itilt.ne.0) Call Albchk(Nwal2,Filen2,Wvla2,Albdo2,
     3 .001*wlmn,.001*wlmx)     
C
C***	CARD 12
C
	READ(14,*) IPRT
	IF(IPRT.EQ.0) GOTO 392
C
C***	CARD 12a if IPRT=1 TO 3 - Modified in 2.9
C	
	READ(14,*)WPMN,WPMX,INTVL
	
	IF(INTVL.LT.0.5)WRITE(16,198)
 198	FORMAT(' *** ERROR ***',//,'  PARAMETER INTVL ON CARD 12a IS',
     & ' LESS THAN 0.5')
     	IF(IPRT.lt.2)goto 392
	OPEN(UNIT=17,FILE=FileExt,RECL=800,STATUS='NEW')
C
C***	CARDS 12b if IPRT=2 TO 3
C	
	READ(14,*)IOTOT
c	If(IOTOT.le.24)goto 391
c	IOTOT=24
c	Write(16,149)
c 149	format(/,'** WARNING! There are too many user-defined variables',
c     2' to be written in File 17.',/,' Only the 24 first selected ',
c    3  'variables will be output!')
c 391	CONTINUE
C
C***	CARDS 12c if IPRT=2 TO 3
C	
 	READ(14,*)(IOUT(i),i=1,IOTOT)
	Out(1) ='Extraterr_spectrum'
	Out(2) ='Dir._normal_irrad.'
	Out(3) ='Difuse_horiz_irrad'
	Out(4) ='Global_horiz_irrad'
	Out(5) ='Direct_horiz_irrad'
	Out(6) ='Direct_tilt_irrad.'
	Out(7) ='Difuse_tilt_irrad.'
	Out(8) ='Global_tilt_irrad.'
	Out(9) ='Direct+circumsolar'
	Out(10)='Difuse-circumsolar'
	Out(11)='Circumsolar_irrad.'
	Out(12)='Global_photon_flux'
	Out(13)='Direct_photon_flux'
	Out(14)='Difuse_photon_flux'
	Out(15)='Rayleigh_transmitt'
	Out(16)='O3___transmittance'
	Out(17)='Trace_gas_transmit'
	Out(18)='H2O__transmittance'
	Out(19)='Mixed_gas_transmit'
	Out(20)='Aerosol_transmitt.'
	Out(21)='Beam_transmittance'
	Out(22)='Rayleigh_opt_thick'
	Out(23)='O3_optic_thickness'
	Out(24)='Tracegas_opt_thick'
	Out(25)='H2O_optical_thick.'
	Out(26)='Mixedgas_opt_thick'
	Out(27)='Aerosol_opt._thick'
	Out(28)='Single_scatt_albdo'
	Out(29)='Aerosol_asymetry_g'
	Out(30)='Zonal_surf._albedo'
	Out(31)='Local_surf._albedo'
	Out(32)='Atmos._reflectance'
	Write(16,147)FileExt
 147	Format(/,'The following spectral variables will be output to ',
     2   'file: ',A24,/)
	Do 390 i=1,IOTOT
	j=IOUT(i)
	Write(16,148) Out(j)
 148	Format(' * ',A18)
 390 	continue
 392	continue
C
C***	CARD 13
C
	READ(14,*) ICIRC
	
	IF(ICIRC.EQ.0)goto 401
C
C***	CARD 13a if ICIRC=1
C
	READ(14,*)slope,apert,limit
	Icirc=-2
	if(apert.le.0.0.and.slope.le.0.0)goto 401
	if(apert.le.0.0.and.limit.le.0.0)goto 401
	Icirc=-1
	if(slope.gt.10.0.or.apert.gt.10.0.or.limit.gt.10.0)goto 401
	if(slope.le.0.0.and.limit.le.0.0)goto 402
	if(limit.le.0.0)limit=2.*apert-slope
	If(slope.le.0.0)slope=2.*apert-limit
	if(apert.le.0.0)apert=.5*(slope+limit)
	nx=1+ifix(limit*10)
	Zxr=limit*rpd
	Znr=slope*rpd
	Icirc=2	
	Zdif=tan(Zxr)-tan(Znr)
	va=(tan(Zxr)+tan(Znr))/Zdif
	vb=2./Zdif
	goto 401
 402	continue
 	Zxr=0.
	Znr=0.
	va=0.
	vb=0.
	nx=1+ifix(apert*10)
 	Icirc=1
 401	continue
C
C***	CARD 14
C
	READ(14,*) ISCAN
C
C***	CARD 14a if ISCAN=1 - Modified in 2.9
C
	FWHM=0.
	IF(ISCAN.ne.1)goto 379
	READ(14,*)IFILT,WV1,WV2,step,FWHM
	OPEN (UNIT=18,FILE=FileScn,STATUS='NEW')
 379	continue
C
C***	CARD 15
C
	READ(14,*)ILLUM
	IF(ILLUM.EQ.0)GOTO 408
	If(Illum.ge.1)Goto 403
	OPEN (UNIT=18,FILE='VLambda.dat',STATUS='OLD')
	Read(18,*)dummy
C
C	PHOTOMETRIC DATA
C
	DO 409 IV=1,421
	READ(18,*)wvli,VL(IV)
 409	CONTINUE
 	CIEYr=24
 	Close (Unit=18,status='keep')
	Goto 408
 403	OPEN (UNIT=19,FILE='VMLambda.dat',STATUS='OLD')
 	Read(19,*)dummy
 	Do 404 IV=1,421
	READ(19,*)wvli,VL(IV)
 404	CONTINUE
 	CIEYr=88
 	Close (Unit=19,status='keep')
C
C***	CARD 16
C
 408	READ(14,*)IUV
C
C	WAVELENGTH LIMITS MANIPULATION
C
	IF(wlmn.LE.280.)wlmn=280.
	IF(WLMX.GE.4000.)WLMX=4000.
 400	IF(ILLUM.NE.1)GOTO 405
	wlmn=MIN(380.,wlmn)
	wlmx=MAX(769.,wlmx)
 405	CONTINUE
 	IF(Abs(ILLUM).NE.2)GOTO 406
	wlmn=280.
	wlmx=4000.
 406	CONTINUE
 	IF(IUV.NE.1)GOTO 419
	wlmn=280.
	WPMN=280.
	wlmx=MAX(400.,wlmx)
	WPMX=MAX(400.,WPMX)
 419	CONTINUE
c
 	Area='ZONAL'
     	If(Ialbdx.ge.0)goto 450
     	WRITE(16,171) Area,RHOX
 171	FORMAT(//,3x,A5,' ALBEDO (constant and Lambertian) = ',F5.3,//)
	Goto 451
 450	Continue
 	Write(16,173) Area,Filen1,Lambr1
 173	Format(//,'  Spectral ',A5,' albedo data: ',A24,/,
     2  '   with a reflection process: ',A14,//)
 451	Continue
     	IF(ICIRC.ge.1)WRITE(16,115)slope,APERT,limit
 115	FORMAT('* GEOMETRY (half-angles) OF THE SIMULATED RADIOMETER ',
     2 '(deg.):',/,'   Slope = ',F5.2,'   Aperture = ',F5.2,
     3 '   Limit = ',F5.2,/)
      If (Icirc.eq.-2) Write(16,151)
 151	Format('** WARNING! The values of both Apert and Slope or Limit'
     2 ,' for the circumsolar',/,' correction are incorrectly less ',
     3 'than or equal to 0.0.',/,'This calculation is therefore ',
     4 'skipped!',/)
     	If(Icirc.eq.1) Write(16,152)
 152	Format('** WARNING! The radiometer''s Slope and Limit angles ',
     2 'are not provided.',/,'Circumsolar calculations will ',
     3 'therefore be performed for',/,'an average geometry ',
     4 'corresponding to the Aperture angle.',/)
     	If(Icirc.eq.-1) Write(16,153)
 153	Format('** WARNING! Circumsolar calculations cannot be done for'
     2  ,' this geometry.',/,'  All half angles must be < 5 deg.',/)
     	If(Itilt.eq.0)Goto 464
     	Area='LOCAL'
     	If(Ialbdg.ge.0)goto 454
	WRITE(16,171) Area,RHOG
	Goto 464
 454	Write(16,173) Area, Filen2,Lambr2
 464	Continue
C
C	PRELIMINARY CALCULATIONS FOR SPECTRAL FUNCTIONS
C
	BETAC=BETA*(0.5**(ALPHA1-ALPHA2))
	EPSIRP=0.1686
C
C***	CARD 17
C
	READ(14,*) IMASS
	
 169	format(8i3)
C
C	SOLAR POSITION LONG DO-LOOP
C
	nread=0
	jday=0
 898	CONTINUE
 	nread=nread+1
	iday=1
c	jday=0
C
	IF(IMASS.NE.1)GOTO 11
C
C***	CARD 17a if IMASS=1
C
	READ(14,*,END=914)ELEV,Azim
	Zenit=90.-ELEV
	GOTO 3
 11	CONTINUE
	IF(IMASS.EQ.2)GOTO 4
	IF(IMASS.EQ.3)GOTO 12
	IF(IMASS.EQ.4)GOTO 19
C
C***	CARD 17a if IMASS=0
C
	READ(14,*,END=914)Zenit,Azim
	GOTO 3
 19	continue
C
C***	CARD 17a if IMASS=4
C
 	READ(14,*,END=914) month,Latit,Dstep
	iscan=0
	if(iprt.eq.2)iprt=0
	if(iprt.eq.3)iprt=1
	jday=jday+1
	dsun=decli(month)
	testx=abs(dsun-Latit)
	if(testx.le.85.)goto 897
	write(16,1099)
 1099	format(/,90('*'),//,'*** ERROR *** Sun is too low for these con',
     1 'ditions--Job aborted!',/,'[This condition must be fulfilled: ',
     2 '|declination - latitude| < 85 deg.',/,'The input data for this',
     3 ' day are such that |declination - latitude| = ',f6.1,' deg.]')
     	goto 898
 897	continue
c 
	suncor=rsun(month)
	phir=Latit*rpd
	cphi=cos(phir)
	sphi=sin(phir)
	tphi=sphi/cphi
	DECR=dsun*rpd
	cdec=cos(decr)
	sdec=sin(decr)
	tdec=sdec/cdec
	q=cphi*cdec
	cosom0=-tphi*tdec
	om0=0.
	if(cosom0.lt.-1.0)om0=pi
	if(cosom0.gt.-1.0.and.cosom0.lt.1.0)om0=acos(cosom0)
	sinom0=SIN(om0)
	sq=sinom0-om0*cosom0
	srise=12.-12.*om0/pi
	daylth=2.*(12.-srise)
c
c     MEAN SOLAR ELEVATION ON THE HORIZONTAL, NO ATMOS. EFFECT
c
	sinh0=0.
	if(om0.gt.0.)SINH0=q*sq/om0
C
C	EXTRATERRESTRIAL IRRADIATION IN MJ/m2
C
	H0nd=.027502*SolarC*suncor*om0
	H0hd=H0nd*sinh0
c
c	Do-loop for incremental zenith angle
c
	iday=0
	Hbnx=0.
	Hbhx=0.
	Hdx=0.
	Hglob=0.
	Hglobs=0.
c	Hiext=0.
	Hibx=0.
	Hidx=0.
	Hig=0.
	His=0.
	Hdose=0.
	cinteg=Dstep/30.
	cstep=.0036*cinteg
	cstepi=cinteg/daylth
	dtime=Dstep/120.
 899	continue
	iday=iday+1
	omr=pi*float(2*iday-1)*dtime/12.
	if(omr.le.(om0-dtime*pi/12.))goto 895
c
c	Daily results
c	
	write(16,1002)H0hd,cstep*Hbhx,cstep*Hdx,cstep*Hglob,cstep*Hglobs,
     1 cstep*Hbnx,cstep*Hglob/H0hd
 1002	Format('* Monthly-average daily-total irradiations (MJ/m2)',/,
     1  '   - Horizontal ',
     3 'surface',/,'   Extraterrestrial: ',f8.3,'    Direct: ',f8.3,
     4 '   Diffuse: ',f8.3,'   Global: ',f8.3,//,'   - Tilted surface',
     5 /,'   Global: ',f8.3,'   Direct normal: ',f8.3,//,'   - Clear',
     6 'ness index (Kt, dimensionless): ',f6.4)
      if(IUV.ne.0)write(16,1003)1000.*cstep*Hdose
 1003 format(//,'* Monthly-average daily-total UV dose (kJ/m2): ',
     1 f8.3)
 	if(iLLUM.ne.0)write(16,1004)
     1 cstepi*Hibx,cstepi*Hidx,cstepi*Hig,cstepi*His,Hiext
 1004	format(//,'* Monthly-average illuminances (klux)',/,
     +  '   - Horizontal surface',/,'    Direct: ',f8.3,'   Diffuse: ',
     1 f8.3,'   Global: ',f8.3,//,'   - Tilted surface',/,'   Global: '
     2 ,f8.3,'   Extraterrestrial normal: ',f8.3,/)
 	goto 898
c
 895	cosom=cos(omr)
	zcos=q*(cosom-cosom0)
	zr=acos(zcos)
	Zenit=zr/rpd
	zsin=sin(zr)
	cosaz=1.
	prod=cphi*zsin
	if(abs(prod).gt.1d-10)cosaz=(sphi*zcos-sdec)/prod
	if(abs(Latit).eq.90.)cosaz=cphi*cosom/zsin
	azr=acos(cosaz)
	if(omr.lt.0.)azr=-azr
	Azim=180.-azr/rpd
	AmR=AMZ(Zenit)
	ITER=0
	GOTO 222 
 12	CONTINUE
C
C***	CARD 17a if IMASS=3 - Modified in 2.9
C
  	READ(14,*,END=914)YEAR,month,DAY,HOUR,Latit,Longit,ZONE
c
	HourUT=Hour-Zone
	if(HourUT.le.24.)goto 601
	HourUT=HourUT-24.
	Day=Day+1
 601	continue
 	if(HourUT.ge.0.)goto 602
	HourUT=HourUT+24.
	Day=Day-1
 602	continue
	CALL SunPSA(HourUT,Latit,Longit,dec,
     1 Zenit,Azim,Julian,Radius,EOT,SPR,TK,Year,Month,Day)
 3	CONTINUE
 	IF(Zenit.LE.90.)GOTO 13
	WRITE(16,103)Zenit
 103	FORMAT(//,'** ERROR! Value of Zenit = ',F6.2,' is > 90 deg.')
 	GOTO 898
 13	CONTINUE
	AmR=AMZ(Zenit)
	DayoYr=Nday(Year,Month,Day)
c
c	Solar Time
c
	SolarH=Hour-(Zone-Longit/15.)+EOT/60.
c
	ITER=0
	GOTO 2
C
C***	CARD 17a if IMASS=2
C
 4	READ(14,*,END=914) AMASS
 	Azim=180.
	IF(AMASS.GT.1.0)GOTO 6
	Zenit=0.
	ITER=0
	GOTO 9
 6	CONTINUE
 	Zenit=90.
	zx=89.75
 	IF(AMASS.GE.35.0)GOTO 99
C
C	FAST ITERATION METHOD TO OBTAIN Zenit FROM AIR MASS
C
	ZXR=ACOS((((1225/AMASS/AMASS)-1)/1224)**0.5)
	ZX=ZXR/RPD
 99	continue
 	If(Amass.le.38.2)goto 98
	Write(16,109)
 109	Format(//,'** ERROR! Value of air mass = ',f6.2,' is > 38.2')
	Goto 898
 98	continue
 	ITER=0
	SignD=1.
	DLTZ=0.5
 20	DLTZ=DLTZ/5.
	ZX=ZX+SignD*DLTZ
	AMX=AMZ(ZX)
	ITER=ITER+1
	EPSI=AMX-AMASS
	IF(ABS(EPSI).LT.0.0005) GOTO 5
	IF(ITER.GE.100) GOTO 5
	IF(EPSI.LT.0.0) GOTO 7
 8	ZX=ZX-DLTZ
 	AMX=AMZ(ZX)
	EPSI=AMX-AMASS
	SignD=1.
	IF(EPSI) 20,5,8
 7	ZX=ZX+DLTZ
 	AMX=AMZ(ZX)
 	EPSI=AMX-AMASS
	SignD=-1.
	IF(EPSI) 7,5,20
 5	CONTINUE
 	Zenit=ZX
 9	CONTINUE
	AmR=AMASS
 2	CONTINUE
	ZR=Zenit*RPD
	ZCOS=COS(ZR)
 222	continue
C
C	NEW PARAMETERIZATIONS FOR THE OPTICAL MASSES
C	(GUEYMARD, SOLAR ENERGY 1993). Revised & augmented for 2.9
C
C	AmR=AMZ(Zenit)   [ALREADY COMPUTED]
	AmH2O=1./(ZCOS+.10648*(Zenit**0.11423)*(93.781-Zenit)**(-1.9203))
	AmO3=1./(ZCOS+1.0651*(Zenit**.6379)*(101.8-Zenit)**(-2.2694))
	AmNO2=1./(ZCOS+1.1212*(Zenit**1.6132)*(111.55-Zenit)**(-3.2629))
	AmNO=1./(ZCOS+.77738*(Zenit**.11075)*(100.34-Zenit)**(-1.5794))
	AmN2=1./(ZCOS+.38155*(Zenit**8.871e-05)*(95.195-Zenit)**(-1.8053))
	AmCO2=1./(ZCOS+.65786*(Zenit**.064688)*(96.974-Zenit)**(-1.8083))
	AmCO=1./(ZCOS+.505*(Zenit**.063191)*(95.899-Zenit)**(-1.917))
	AmCH4=1./(ZCOS+.49381*(Zenit**.35569)*(98.23-Zenit)**(-2.1616))
	AmN2O=1./(ZCOS+.61696*(Zenit**.060787)*(96.632-Zenit)**(-1.8279))
	AmO2=1./(ZCOS+.65779*(Zenit**.064713)*(96.974-Zenit)**(-1.8084))
	AmNH3=1./(ZCOS+.32101*(Zenit**.010793)*(94.337-Zenit)**(-2.0548))
	AmSO2=1./(ZCOS+.63454*(Zenit**.0099198)*(95.804-Zenit)**(-2.0573))
	AmHNO3=1./(ZCOS+1.044*(Zenit**.78456)*(103.15-Zenit)**(-2.4794))
c	AmHNO4=1./(ZCOS+.92716*(Zenit**.080263)*(96.303-Zenit)**(-1.6709))
c	AmN2O5=1./(ZCOS+1.0497*(Zenit**.48545)*(99.455-Zenit)**(-2.1117))
	AmAER=1./(ZCOS+.16851*(Zenit**.18198)*(95.318-Zenit)**(-1.9542))
	AmCH2O=AmN2O
	AmClNO=AmNO2
	AmHNO2=AmHNO3
	AmNO3=AmNO2
	AmBrO=AmO3
	AmPOL=1./(.0001569+.9998431*zcos*zcos)**.5
c
	amw1=AmH2O-1.
c
	if(imass.ne.4)WRITE(16,172)Zenit,Azim,AmR,AmH2O,AMO3,AMNO2,AmAER
 172	FORMAT(2(/,100('=')),//,'* SOLAR POSITION (deg.):',/,4x,
     $ 'Zenith Angle (apparent) = ',F6.3,'  Azimuth (from North) = ',
     2 F7.2,//,'  RELATIVE OPTICAL MASSES:',/,'  - Rayleigh',
     #' = ',F6.3,/,'  - Water Vapor = ',F6.3,/,'  - Ozone'
     $,' = ',F6.3,/,'  - NO2 = ',F6.3,/,'  - Aerosols = ',F6.3,/)
     	IF(IMASS.EQ.3)WRITE(16,170)YEAR,Month,DAY,Hour,JULIAN,DayoYr,
     1 HourUT,DEC,RADIUS,EOT,SolarH
 170 	FORMAT('  Results below are for this specific day:',/,'   Year',
     1 ' = ',I4,'  Month = ',i2,'  Day = ',I2,'  Hour (LST) = ',f6.3,/,
     2 '   Julian Day = ',f12.3,'  Day of Year = ',i3,'  Hour (Univers'
     3 ,'al Time) = ',F6.3,/,'   Declination = ',F7.3,' deg.',
     $ '  Radius vector = ',F7.5,'  Equation of Time (min) = ',f7.3,
     5 /,'   Local Apparent Time (or Solar Time): ',f7.3,//)
c
	if(imass.eq.4)goto 223
	Zenit=Min(90.,Zenit)
	ELEV=90.-Zenit
	ZR=Zenit*RPD
	ZCOS=COS(ZR)
 223	continue
	ZSIN=SIN(ZR)
	EPSIR=0.17*(1.-EXP(-8.*ZCOS))
	SIGMAR=3.65-2.3*EXP(-4.*ZCOS)
	EXPR=0.72+ZCOS
	ZCOS1=MAX(.07,ZCOS)
	EXPA=-.5+EXP(.24/(ZCOS1**1.24))
	FHTA2=(-11.012+12.392*AMO3)/(1.+.23644*AMO3)
	FHTA1=3.2656*(1.-EXP(-.46464*AMO3**1.25))-.965936*FHTA2
	FHTA0=2.*FHTA1+1.93187*FHTA2
	FHTB1=EXP(.31045+.001684*AMO3-.28549/AMO3**4)
c
	IF(IMASS.EQ.3)SUNCOR=1./RADIUS**2
c
c	Gas Abundances for total column in atm-cm
c
	if(nread.gt.1)goto 837
	AbO2=1.6764E5*pp0*(TT0**.019778)
	AbCH4=1.262287*pp0*(TT0**.32546)
	AbCO=.088845*(pp0**1.3769)/(TT0**.29089)
	AbN2O=.23851*(pp0**1.0993)
	AbCO2=.80212*qCO2*pp0*(TT0**.019788)
	AbN2=3.8212*(pp0**1.8349)/(TT0**.50342)
	AbHNO3=3.6739e-4*(pp0**.13568)*(TT0**.68361)
	AbNO2=unc
	AbNO=3.1464e-4*(pp0**.72403)*(TT0**.37879)
	AbSO2=1.097e-4*(pp0**2.2448)/(TT0**.45323)
	AbNH3=1.2892e-4*(pp0**1.0838)*(TT0**.1616)
	AbO4=1.8171e4*NLosch*NLosch*(pp0**1.7984)/(TT0**.344)
	AbBrO=2.5E-06
	AbNO3=.00005
	AbCH2O=.0003
	AbHNO2=.0001
	AbClNO=.00012
	AbO3=uoc
c
	if(iday.eq.1.and.jday.le.1)write(16,174)qCO2
 174	format(/,' CO2 Mixing Ratio (ppmv): ',f6.1,//)
	if(iday.eq.1.and.jday.le.1.and.nread.eq.1)Write(16,101)AbBrO,
     3 AbCH2O,AbCH4,AbClNO,AbCO,AbCO2,AbHNO2,AbHNO3,AbNH3,AbNO,AbNO2,
     2 AbNO3,AbN2,AbN2O,AbO2,AbO3,AbO2,AbSO2
 101	Format(/,' Total column abundances for all gases except H2O ',
     1 '(atm-cm) and normal/standard conditions:',//,
     2 '   BrO        CH2O       CH4        ClNO3      CO         CO2',
     3 '        HNO2       HNO3       NH3',//,9(e10.4,1x),///,
     3 '   NO         NO2        NO3        N2         N2O      '
     4 ,'  O2         O3         O4         SO2',//,9(e10.4,1x),///)
      if(iGas.eq.1)goto 837
	AtCH4=AbCH4+ApCH4
	AtCO=AbCO+ApCO
	AtHNO3=AbHNO3+ApHNO3
	AtNO2=AbNO2+ApNO2
	AtNO=AbNO+ApNO
	AtSO2=AbSO2+ApSO2
	AtNO3=AbNO3+ApNO3
	AtO3=AbO3+ApO3
	AtCH2O=AbCH2O+ApCH2O
	AtHNO2=AbHNO2+ApHNO2
	AtO2=AbO2
	AtN2O=AbN2O
	AtCO2=AbCO2
	AtN2=AbN2
	AtNH3=AbNH3
	AtBrO=AbBrO
	AtClNO=AbClNO	
c     
      if(iday.eq.1.and.jday.le.1)Write(16,102)Load,
     2 AtBrO,AtCH2O,AtCH4,AtClNO,AtCO,AtCO2,AtHNO2,AtHNO3,AtNH3,AtNO,
     3 AtNO2,AtNO3,AtN2,AtN2O,AtO2,AtO3,AtO2,AtSO2
 102	Format(' Corrected total column abundances for all gases '
     1 ,'(atm-cm)',/,' with these realistic conditions: ',A24,//,
     2 '   BrO        CH2O       CH4        ClNO3      CO         CO2',
     3 '        HNO2       HNO3       NH3',//,9(e10.4,1x),///,
     3 '   NO         NO2        NO3        N2         N2O      '
     4 ,'  O2         O3         O4         SO2',//,9(e10.4,1x),///)
 837	continue
C
C
C	"CDRS" DIFFUSE TILT MODEL ACCORDING TO GUEYMARD
C		(SOLAR ENERGY 1987)
C
	If(Itilt.eq.0)Goto 453
	Tilt0=Tilt
	Wazim0=Wazim
	If(Tilt.lt.-400.)Tilt=Zenit
	If(Wazim.lt.-400.)Wazim=Azim
	SR=TILT*RPD
	Swa=(Azim-Wazim)*RPD
	Rdi=1.
	Rd=1.
	Tetas=Zenit
	H1=ELEV/100.
	CSR=COS(SR)
	SSR=SIN(SR)
	CS1=1.0
	If(Tilt0.ge.0.)CS1=CSR*ZCOS+SSR*ZSIN*COS(Swa)
	TETAS=ACOS(CS1)/RPD
	CS2=CS1*CS1
	CS3=CS2*CS1
	RBN=AMAX1(0.,CS1)
	RDI=(1.+CSR)/2.
	RG=(1.-CSR)/2.
	DA0=A0
	DA1=A1
	DA2=A2
	DA3=A3
	RDH0=RD0
	DO 10 K=1,4
	HK1=H1**K
	DA0=DA0+RB0(K)*HK1
	DA1=DA1+RB1(K)*HK1
	DA2=DA2+RB2(K)*HK1
	DA3=DA3+RB3(K)*HK1
	RDH0=RDH0+RDHB(K)*HK1
 10	CONTINUE
 	RDC=EXP(DA0+DA1*CS1+DA2*CS2+DA3*CS3)
	RDS=(1.-.2249*SSR**2+.1231*SIN(2.*SR)-.0342*SIN(4.*SR))/.7751
	RD=RDC+RDH0*RDS
	if(imass.ne.4) WRITE(16,112)TILT,WAZIM,TETAS,Rdi,Rd
 112	FORMAT(/,'* ANGLES (deg.) FOR TILTED SURFACE CALCULATIONS: ',/,
     %'   Surface Tilt = ',F7.3,
     $ '   Surface Azimuth (from North) = ',F7.3,/,1X,
     #'  Incidence Angle = ',F7.3,//,
     5'  Diffuse irradiance ratios (tilted plane/horizontal):',/,
     6 5x,F7.4,'  (isotropic approximate conversion--for reference)',
     7 /,5x,F7.4,'  (anisotropic conversion model--used here)',//)
     	Tilt=Tilt0
	Wazim=Wazim0
 453	Continue
c
c  	Z=zenit
C
c-----------------------------------------------
c	
C	Start reading the selected E.T. SPECTRUM file
C
	if(nread.gt.1)goto 787
	if(imass.eq.4.and.iday.gt.1)goto 787
	READ(15,*)Spctrm
 	READ(15,*)ESC
	ESCC=SUNCOR*SolarC
	Scor=Escc/Esc
	Scor2=SolarC/Esc
c 
	if(iday.eq.1.and.nread.le.1)WRITE(16,126)ESCC,
     1 SUNCOR,SolarC,Spctrm
 126	FORMAT(/,33('*',2x),//,x'* SPECTRUM:',/,'  Total (0-100 m) ',
     $ 'Extraterrestrial Irradiance used here = ',F7.2,' W/m2',/,
     #'  (i.e., ',F6.4,' times the selected solar constant, ',f7.2,
     4 ' W/m2, due to the actual Sun-Earth distance.)',/,'  Source'
     5 ,' for selected solar spectrum: ',A24,/)
      If(Scor2.ne.1.0.and.iday.eq.1.and.jday.le.1.and.nread.le.1)
     * write(16,127)Scor2
 127	format(' To account for the chosen Solar Constant value, the ',
     2 'selected solar spectrum has been uniformly scaled',/,
     3 ' by a scaling coefficient = ',f6.4,/)
c        	 	
	if(imass.eq.4.and.iday.eq.1)write(16,1001)month,
     1 Latit,srise,daylth,Dstep
 1001	Format(//,' Mean daily results for the average day of'
     1 ,' month ',i2,' at latitude: ',f7.3,' deg.',/,' Time of sunrise'
     2 ,' (hr): ',f6.3,'   Daylength (hr): ',f6.3,'  Time integration',
     3 ' step (min): ',f5.1,/)
c
c	Rewind data files for new runs
c
	goto 788
 787	continue
	Rewind 15
	Rewind 22
	Rewind 25
	Rewind 26
	Rewind 27
	Rewind 28
	Rewind 29
	Rewind 30
	Rewind 31
	Rewind 32
	Rewind 33
	Rewind 34
	Rewind 35
	Rewind 36
	Rewind 37
	Rewind 38
	Rewind 39
	Rewind 40
	Rewind 41
	if(w.gt.0.)Rewind 21
	if(AbO3.gt.0.)Rewind 23
	if(AbO3.gt.0.)Rewind 24
	read(22,*)dummy
	read(25,*)dummy
	read(26,*)dummy
	read(27,*)dummy
	read(28,*)dummy
	read(29,*)dummy
	read(30,*)dummy
	read(31,*)dummy
	read(32,*)dummy
	read(33,*)dummy
	read(34,*)dummy
	read(35,*)dummy
	read(36,*)dummy
	read(37,*)dummy
	read(38,*)dummy
	read(39,*)dummy
	read(40,*)dummy
	read(41,*)dummy
	if(w.gt.0.)read(21,*)dummy
	if(AbO3.gt.0.)read(23,*)dummy
	if(AbO3.gt.0.)read(24,*)dummy
c	
C	Start reading the selected E.T. SPECTRUM file
C
	READ(15,*)Spctrm
 	READ(15,*)ESC
	ESCC=SUNCOR*SolarC
	Scor=Escc/Esc
	Scor2=SolarC/Esc
c 
	if(iday.eq.1)WRITE(16,126)ESCC,
     1 SUNCOR,SolarC,Spctrm
      If(Scor2.ne.1.0.and.iday.eq.1.and.jday.le.1)write(16,127)Scor2
c
	if(imass.eq.4.and.iday.eq.1)write(16,1001)month,
     1 Latit,srise,daylth,Dstep
c
 788	continue
C
c-----------------------------------------------
c
C	INITIALIZATION FOR BROADBAND RESULTS
C
	SUMB=0.
	SUMBX=0.
	SUMD=0.
	SUMDR=0.
	SUMDA=0.
	SUMDX=0.
	SUMG=0.
	SUMBN=0.
	SUM0=0.
	SUMBS=0.
	SUMDS=0.

	SUMRS=0.
	SUMGS=0.
	IWVL=0
	BILLUM=0.
	DILLUM=0.
	SILLUM=0.
	XILLUM=0.
	BILLX=0.
	DILLX=0.
	SERY0=0.
	SERY1=0.
	SERY2=0.
	SERY3=0.
	SERY4=0.
	SDNA=0.
	SECAL=0.
	SPHO=0.
	SACG=0.
	SPOL=0.
	SSIS=0.
	SPRT=0.
	SSCUPH=0.
	SSCUPM=0.
	SUVA1=0.
	SUVB1=0.
	SUVA2=0.
	SUVB2=0.
C 	 	
     	IF(IPRT.le.0.or.IPRT.eq.2.or.imass.eq.4)goto 65
	If(Itilt.ne.0.or.Icirc.ne.0)goto 60
	WRITE(16,110)
 110	FORMAT('*** IRRADIANCES IN W/(m2 nm) AND TRANSMITTANCES FOR A ',
     2  'GIVEN WAVELENGTH (in nm)',
     3  //,' WVLGTH',2X,'SPCTRM',5X,'BEAM',8X,'BEAM',8X,'DIFF',
     4  8X,'GLOB',/,
     7  18X,' NORMAL',3X,'------------ HORIZONTAL -----------',/)
     	goto 65
 60	continue
	IF(Itilt.ne.0.or.Icirc.ne.1)goto 61
	WRITE(16,114)
 114	FORMAT('*** IRRADIANCES IN W/(m2 nm) FOR A ',
     2  'GIVEN WAVELENGTH (in nm)',
     3  //,'WVLGTH',2X,'SPCTRM',6X,'BEAM',8X,'DIFF',
     4  8X,'GLOB',8X,'BEAM EXP',4X,'DIF EXP',/,
     5  18X,' NORMAL',3X,'------ HORIZONTAL -----    ------- NORMAL',
     6  ' -------',/)
     	goto 65
 61	IF(Itilt.ne.1.or.Icirc.ne.0)goto 62
	WRITE(16,111)
 111	FORMAT('*** IRRADIANCES IN W/m2 nm FOR A ',
     2  'GIVEN WAVELENGTH (in nm)',//
     3  ,'WVLGTH',2X,'SPCTRM',6X,'BEAM',8X,'DIFF',
     4  8X,'GLOB',8X,'DIFF',7X,'GLOB',/,
     7  18X,' NORMAL',3X,'------ HORIZONTAL -----',
     8  3X,'-------- TILTED -------',/)
 	GOTO 65
 62	CONTINUE
 	WRITE(16,116)
 116	FORMAT('*** IRRADIANCES IN W/m2 nm FOR A ',
     2  'GIVEN WAVELENGTH (in nm)',//
     3  ,'WVLGTH',2X,'SPCTRM',6X,'BEAM',8X,'DIFF',
     4  8X,'GLOB',8X,'BEAM EXP',8X,'DIFF',8X,'GLOB',/,
     7  18X,' NORMAL',3X,'------ HORIZONTAL -----   -- NORMAL--',
     8  '    ---- TILTED PLANE ---',/)
 65	CONTINUE
     	If(IPRT.ge.2) Write(17,113) (Out(Iout(i)),i=1,IOTOT)
 113	Format('Wvlgth',32(1x,A18))
C
c-----------------------------------------------
c-----------------------------------------------
c
C***	START SPECTRAL CALCULATIONS
C
	IWVL=0
	WVOLD=wlmn-1.
	IF(wlmn.GE.1705.)WVOLD=wlmn-5.
	iF(wlmn.le.400.)WVOLD=wlmn-0.5
	
 15	READ (15,*,END=999) IWVLN1,H0
 
	WVLn=FLOAT(IWVLN1)/10.
	WVL=wvln/1000.
c	H0=H0/1000.
	IF(WVLN.LE.WVOLD)GOTO 15
	IF(WVLN.GT.wlmx)GOTO 999
	H0=H0*Scor
	WVOLD=WVLN
	IWVL=IWVL+1
	wv(IWVL)=WVLN
	WVL2=WVL*WVL
	WVL3=WVL*WVL2
	WVL4=WVL*WVL3
C
c-----------------------------------------------
c
C**	RAYLEIGH SCATTERING FUNCTION - Revised in 2.9
C
	TAURL=pp0/(117.3405*WVL4-1.5107*WVL2 + .017535
     % -8.7743E-4/WVL2)
     	TR=EXP(-AmR*TAURL)
C
c-----------------------------------------------
c
C**	WATER VAPOR ABSORPTION - Fundamentally revised in 2.9
C	
	TH2O=1.
	TH2OP=1.	
c	
	if(wvln.lt.440.0.or.w.le.0.0)goto 17
 73	READ (21,*,END=17) wvlw,AW,iband,ifitw,bwa0,bwa1,bwa2,
     1 ifitm,bma0,bma1,bma2,ifitmw,bmwa0,bmwa1,bmwa2,bpa1,bpa2
 	if(abs(wvln-wvlw).gt.epsilm)goto 73
	IF(AW.le.0.0)GOTO 17
c	
	Bw=1.
	w0=4.11467
	if(iband.eq.2)w0=2.92232
	if(iband.eq.3)w0=1.41642
	if(iband.eq.4)w0=.41612
	if(iband.eq.5)w0=.05663
	ww0=w-w0
	ww02=ww0*ww0
	Bw=1.+bwa0*ww0+bwa1*ww02
	if(ifitw.eq.1)Bw=Bw/(1.+bwa2*ww0)
	if(ifitw.eq.2)Bw=Bw/(1.+bwa2*ww02)
	if(ifitw.eq.6)Bw=bwa0+bwa1*ww0
c	
	Bm=1.
	Bmp=1.
	do 72 im=1,2
	xamw=AmH2O
	if(im.eq.2)xamw=1.66
	xamw1=xamw-1.
	xamw11=xamw1**.1
	xamw12=xamw1*xamw1
	xamw15=xamw1**.5
	xamw25=xamw1**.25
c	
	if(ifitm.eq.0)Bmx(im)=bma1*(xamw**bma2)
	if(ifitm.eq.1)Bmx(im)=(1.+bma0*xamw1+bma1*xamw12)/
     1 (1.+bma2*xamw1)
      if(ifitm.eq.2)Bmx(im)=(1.+bma0*xamw1+bma1*xamw12)/
     1 (1.+bma2*xamw12)
     	if(ifitm.eq.3)Bmx(im)=(1.+bma0*xamw1+bma1*xamw12)/
     1 (1.+bma2*xamw15)
      if(ifitm.eq.5)Bmx(im)=(1.+bma0*xamw25)/(1.+bma2*xamw11)
 72	continue
c	
	Bm=Bmx(1)
	Bmp=Bmx(2)
	Bm=max(Bm,.05)
	Bm=min(Bm,7.0)
	Bmp=max(Bmp,.1)
	Bmp=min(Bmp,6.0)
	Bw=max(Bw,.05)
	Bw=min(Bw,7.0)
	Bmw=Bm*Bw
	Bmwp=Bmp*Bw	
	if(abs(Bw-1.).lt.epsilm)goto 75
	if(ifitm.ne.0.and.abs(Bm-1.).lt.epsilm)goto 75
	if(ifitm.eq.0.and.Bm.gt.0.968.and.Bm.lt.1.0441)goto 75
	if(ifitmw.eq.-1)goto 75
 	Bmw=1.
	wfw0=w/w0
	do 74 im=1,2
	xamw=AmH2O
	if(im.eq.2)xamw=1.66
	yamw=xamw*wfw0
	yamw1=yamw-1.
	yamw12=yamw1*yamw1	
	if(ifitmw.eq.0)Bmwx(im)=bmwa1*(yamw**bmwa2)
	if(ifitmw.eq.1)Bmwx(im)=(1.+bmwa0*yamw1+bmwa1*yamw12)/
     1 (1.+bmwa2*yamw1)
      if(ifitmw.eq.2)Bmwx(im)=(1.+bmwa0*yamw1+bmwa1*yamw12)/
     1 (1.+bmwa2*yamw12)
 74	continue
 	Bmw=Bmwx(1)
	Bmwp=Bmwx(2)
	Bmw=max(Bmw,.05)
	Bmw=min(Bmw,7.0)
	Bmwp=max(Bmwp,.1)
	Bmwp=min(Bmwp,6.)
 75	continue
c
	Bp=1.
	wamw=w*AmH2O
	if(qp.eq.0.)goto 78	
	pp02=pp0*pp0
	qp2=qp*qp
	Bp=1.+.1623*qp
	if(iband.eq.2)Bp=1.+.08721*qp
	if(iband.eq.3)Bp=1.-bpa1*qp-bpa2*qp2
	if(iband.eq.4)Bp=(1.-exp(-.63486+6.9149*pp0-13.853*pp02)
     1  *wamw)*(1.-bpa1*qp-bpa2*qp2)
     	if(iband.eq.5)Bp=(1.-wamw*exp(8.9243-18.197*pp0+2.4141*pp02))
     1 *(1.-bpa1*qp-bpa2*qp2)
	Bp=max(Bp,.3)
	Bp=min(Bp,1.7)
 78	continue
c 	
c	Bcor=Bmw*Bp
c	Bcorp=Bmwp*Bp
	wAmw=(w*AmH2O)**.9426
	wAmp=(1.66*w)**.9426
c		
	Tauw=Bmw*Bp*Aw*wAmw
      TH2O=EXP(-Tauw)
      TH2OP=EXP(-Bmwp*Bp*Aw*wAmp)
      Tauw=Tauw/AmH2O
 17	CONTINUE
C
c-----------------------------------------------
c
c	Absorption from all other gases - Fundamentally revised in 2.9
c
c	Those in variable quantities due to pollution are treated in 
c	subroutines
c
C**	Uniformly mixed gases
C
c	1. Oxygen (O2)
c
	TO2=1.
	TO2P=1.
	if(wvln.lt.627.0.or.WVLN.GT.1581.0)goto 801
 800	READ (22,*,END=801) wvlo,AO2
 	if(wvln.ne.wvlo)goto 800
	IF(AO2.le.0.0)GOTO 801
	tauo2=AO2*AbO2
	TO2=exp(-(tauo2*AmO2))
	TO2P=exp(-(tauo2*1.66))
	goto 803
 801	continue
 	goto 803
 802	READ (42,*,END=803) wvlo,xsO2
 	if(abs(wvln-wvlo).gt.epsilm)goto 802
c	IF(xsO2.le.0.0)GOTO 803
	AO2=xsO2*NLosch
	TO2=exp(-AO2*AbO2*AmO2)
	TO2P=exp(-AO2*AbO2*1.66)
 803	continue
C
c	2. Methane (CH4)
c
	TCH4=1.
	TCH4P=1.
	If(AbCH4.le.0.)goto 853
	if(wvln.lt.1617.0)goto 853
 852	READ (36,*,END=853) wvlo,ACH4
 	if(abs(wvln-wvlo).gt.epsilm)goto 852
	IF(ACH4.le.0.0)GOTO 853
	Call G$CH4(ACH4,AbCH4,AmCH4,TCH4,TCH4P)
 853	continue
C
c	3. Carbon Monoxide (CO)
c
	TCO=1.
	TCOP=1.
	If(AbCO.le.0.)goto 855
	if(wvln.lt.2310.0.or.wvln.gt.2405.)goto 855
 854	READ (34,*,END=855) wvlo,ACO
 	if(abs(wvln-wvlo).gt.epsilm)goto 854
	Call G$CO(ACO,AbCO,AmCO,TCO,TCOP)
 855	continue
C
c	4. Nitrous oxide (N2O)
c
	TN2O=1.
	TN2OP=1.
	if(wvln.lt.1950.0)goto 807
 806	READ (27,*,END=807) wvlo,AN2O
 	if(abs(wvln-wvlo).gt.epsilm)goto 806
	IF(AN2O.le.0.0)GOTO 807
	TN2O=exp(-(AN2O*AbN2O*AmN2O))
	TN2OP=exp(-(AN2O*AbN2O*1.66))
 807	continue
C
c	5. Carbon Dioxide (CO2)
c
	TCO2=1.
	TCO2P=1.
	if(wvln.lt.1036.0)goto 809
 808	READ (35,*,END=809) wvlo,ACO2
 	if(abs(wvln-wvlo).gt.epsilm)goto 808
	IF(ACO2.le.0.0)GOTO 809
	tauco2=ACO2*AbCO2
	TCO2=exp(-(tauco2*AmCO2))
	TCO2P=exp(-(tauco2*1.66))
 809	continue
C
c	6. Nitrogen (N2)
c
	TN2=1.
	TN2P=1.
	if(wvln.lt.3645.0)goto 811
 810	READ (26,*,END=811) wvlo,AN2
 	if(abs(wvln-wvlo).gt.epsilm)goto 810
c	IF(AN2.le.0.0)GOTO 811
	TN2=exp(-(AN2*AbN2*AmN2))
	TN2P=exp(-(AN2*AbN2*1.66))
 811	continue	
C
c	7. Oxygen-oxygen (O2-O2 or O4) 
c
c	[Collision-induced absorption; also includes O2-N2]
c
	TO4=1.
	TO4P=1.
	if(WVLN.GT.1593.0)goto 827
 826	READ (25,*,END=827) wvlo,xsO4
 	if(abs(wvln-wvlo).gt.epsilm)goto 826
	IF(xsO4.le.0.0)GOTO 827
	AO4=xsO4*1d-46
	TO4=exp(-AO4*AbO4*AmO2)
	TO4P=exp(-AO4*AbO4*1.66)
 827	continue
c
c
C**	Misc. Trace gases
C
c	1. Nitric acid (HNO3)
c
	THNO3=1.
	THNO3P=1.
	If(AbHNO3.le.0.)goto 863
	if(wvln.gt.350.0)goto 863
 862	READ (31,*,END=863) wvlo,xsHNO3,athno3
 	if(abs(wvln-wvlo).gt.epsilm)goto 862
	Call G$HNO3(234.2,xsHNO3,athno3,AbHNO3,AmHNO3,THNO3,
     1 THNO3P)
 863	continue
C
c	2. Nitrogen dioxide (NO2)
c
	TNO2=1.
	TNO2P=1.
	if(AbNO2.le.0.)goto 865
	if(wvln.gt.926.0)goto 865
 864	READ (29,*,END=865) wvlo,xsNO2,atno2
 	if(abs(wvln-wvlo).gt.epsilm)goto 864
	Call G$NO2(TempN,xsNO2,atno2,AbNO2,AmNO2,TNO2,TNO2P)
 865	continue
C
c	3. Nitrogen trioxide (NO3)
c
	TNO3=1.
	TNO3P=1.
	if(AbNO3.le.0.)goto 867
	if(wvln.lt.400.0.or.wvln.gt.703.0)goto 867
 866	READ (30,*,END=867) wvlo,xsNO3,atno3
 	if(abs(wvln-wvlo).gt.epsilm)goto 866
	Call G$NO3(TempN,xsNO3,atno3,AbNO3,AmNO3,TNO3,TNO3P)
 867	continue
C
c	4. Nitric oxide (NO)
c
	TNO=1.
	TNOP=1.
	If(AbNO.le.0.)goto 869
	if(wvln.lt.2645.0.or.wvln.gt.2745.)goto 869
 868	READ (28,*,END=869) wvlo,ANO
 	if(abs(wvln-wvlo).gt.epsilm)goto 868
	Call G$NO(ANO,AbNO,AmNO,TNO,TNOP)
 869	continue
C
c	5a. Sulfur Dioxide (SO2) [UV band]
c
	TSO2=1.
	TSO2P=1.
	If(AbSO2.le.0.)goto 823
	if(wvln.gt.420.0)goto 821
 820	READ (32,*,END=821) wvlo,xsSO2,atso2
 	if(abs(wvln-wvlo).gt.epsilm)goto 820
c	IF(xsSO2.le.0.0)GOTO 821
	Call G$SO2U(247.1,xsSO2,atso2,AbSO2,AmSO2,TSO2,TSO2P)
 821	continue
C
c	5b. Sulfur Dioxide (SO2) [IR band]
c
	if(wvln.lt.3955.0)goto 823
 822	READ (33,*,END=823) wvlo,ASO2
 	if(abs(wvln-wvlo).gt.epsilm)goto 822
c	IF(ASO2.le.0.0)GOTO 823
	Call G$SO2I(ASO2,AbSO2,AmSO2,TSO2,TSO2P)	
 823	continue
C
c	6a. Ozone (O3) [UV and VIS bands]
c
	TO3=1.0
	TAUZ3=0.
	IF(AbO3.le.0.0)GOTO 875
	if(wvln.gt.1091.)goto 872
 870	read(23,*,end=872)wvlo,xso3,a0o3,a1o3
	if(abs(wvln-wvlo).gt.epsilm)goto 870
c	if(xso3.le.0.)goto 872
	Tref=223.
	if(wvl.lt.345.)Tref=228.
	Call G$O3U(Tref,Tempo,xso3,a0o3,a1o3,Abo3,AmO3,tauz3,TO3,xo3,AO3)
c	TO3=Txo3

	
c	write(16,911)wvl,xso3,xo3,ao3,tauz3,to3
 911	format(1(f10.4,1x),2(e10.4,1x),3(d10.4,1x))
 

	goto 875
 872	continue
c
c	6b. Ozone (O3) [IR bands]
c
	if(wvln.lt.2470.)goto 875
 874	read(24,*,end=875)wvlo,AO3
	if(abs(wvln-wvlo).gt.epsilm)goto 874
	TO3=exp(-AO3*AbO3*AmO3)
 875	continue
c
c	7. Ammonia (NH3)
c
	TNH3=1.
	TNH3P=1.
	if(wvln.lt.1900.0)goto 825
 824	READ (37,*,END=825) wvlo,ANH3
 	if(abs(wvln-wvlo).gt.epsilm)goto 824
	IF(ANH3.le.0.0)GOTO 825
	TNH3=exp(-ANH3*AbNH3*AmNH3)
	TNH3P=exp(-ANH3*AbNH3*1.66)
 825	continue	
C
c	8. Bromine monoxide (BrO)
c
	TBrO=1.
	TBrOP=1.
	if(wvln.lt.296.5.or.WVLN.GT.384.5)goto 829
 828	READ (38,*,END=829) wvlo,xsBrO
 	if(abs(wvln-wvlo).gt.epsilm)goto 828
	ABrO=xsBrO*NLosch
c	IF(ABrO.le.0.0)GOTO 829
	TBrO=exp(-ABrO*AbBrO*AmBrO)
	TBrOP=exp(-ABrO*AbBrO*1.66)
 829	continue	
C
c	9. Formaldehyde (CH2O)
c
	TCH2O=1.
	TCH2OP=1.
	If(AbCH2O.le.0.)goto 831
	if(WVLN.GT.400.0)goto 831
 830	READ (39,*,END=831) wvlo,xsCH2O,atCH2O
 	if(abs(wvln-wvlo).gt.epsilm)goto 830
	Call G$CH2O(TK-24.,xsCH2O,atCH2O,AbCH2O,AmCH2O,
     1 TCH2O,TCH2OP)
 831	continue
C
c	10. Nitrous acid (HNO2)
c
	THNO2=1.
	THNO2P=1.
	If(AbHNO2.le.0.)goto 833
	if(wvln.lt.300.5.or.WVLN.GT.396.5)goto 833
 832	READ (40,*,END=833) wvlo,xsHNO2
 	if(abs(wvln-wvlo).gt.epsilm)goto 832
	Call G$HNO2(234.,xsHNO2,AbHNO2,AmHNO2,THNO2,THNO2P)
 833	continue
C
c	11. Chlorine nitrate (ClNO3)
c
	TClNO=1.
	TClNOP=1.
	TCl=230.
	if(WVLN.GT.432.0)goto 835
 834	READ (41,*,END=835) wvlo,xsClNO,a1tCl,a2tCl
 	if(abs(wvln-wvlo).gt.epsilm)goto 834
	AClNO=xsClNO*(1.+a1tCl*(TCl-296.)+a2tCl*(TCl-296.)*(TCl-296.))*
     2 NLosch
c	IF(AClNO.le.0.0)GOTO 835
	TClNO=exp(-AClNO*AbClNO*AmClNO)
	TClNOP=exp(-AClNO*AbClNO*1.66)
 835	continue	
c
	if(iGas.ne.0) goto 891
c
c	Supplemental absorption due to non-standard conditions (pollution...)
c
c	2. Methane (CH4)
c
	if(wvln.lt.1617.0)goto 880
	Call G$CH4(ACH4,ApCH4,AmPOL,Tcor,TcorP)
	TCH4=Min(TCH4*tcor,1.)
	TCH4P=Min(TCH4P*tcorp,1.)
 880	continue
C
c	3. Carbon Monoxide (CO)
c
	if(wvln.lt.2310.0.or.wvln.gt.2405.)goto 881
	Call G$CO(ACO,ApCO,AmPOL,
     1 Tcor,TcorP)
	TCO=Min(TCO*tcor,1.)
	TCOP=Min(TCOP*tcorp,1.)
 881	continue
C
C**	Misc. Trace gases
C
c	1. Nitric acid (HNO3)
c
	if(wvln.gt.350.0)goto 882
	Call G$HNO3(TK,xsHNO3,athno3,ApHNO3,
     1 AmPOL,Tcor,TcorP)
	THNO3=Min(THNO3*tcor,1.)
	THNO3P=Min(THNO3P*tcorp,1.)
 882	continue
C
c	2. Nitrogen dioxide (NO2)
c
	if(wvln.gt.926.0)goto 883
	Call G$NO2(TK,xsNO2,atno2,ApNO2,AmPOL,
     1 Tcor,TcorP)
	TNO2=Min(TNO2*tcor,1.)
	TNO2P=Min(TNO2P*tcorp,1.)
 883	continue
C
c	3. Nitrogen trioxide (NO3)
c
	if(wvln.lt.400.0.or.wvln.gt.703.0)goto 884
	Call G$NO3(TK,xsno3,atno3,ApNO3,AmPOL,Tcor,TcorP)
	TNO3=Min(TNO3*tcor,1.)
	TNO3P=Min(TNO3P*tcorp,1.)
 884	continue
C
c	4. Nitric oxide (NO)
c
	if(wvln.lt.2645.0.or.wvln.gt.2745.)goto 885
	Call G$NO(ANO,ApNO,AmPOL,
     1 Tcor,TcorP)
	TNO=Min(TNO*tcor,1.)
	TNOP=Min(TNOP*tcorp,1.)
 885	continue
C
c	5a. Sulfur Dioxide (SO2) [UV band]
c
	if(wvln.gt.420.0)goto 886
	Call G$SO2U(TK,xsSO2,atso2,ApSO2,
     1 AmPOL,Tcor,TcorP)
	TSO2=Min(TSO2*tcor,1.)
	TSO2P=Min(TSO2P*tcorp,1.)
 886	continue
C
c	5b. Sulfur Dioxide (SO2) [IR band]
c
	if(wvln.lt.3955.0)goto 887
	Call G$SO2I(ASO2,ApSO2,AmPOL,Tcor,TcorP)
	TSO2=Min(TSO2*tcor,1.)
	TSO2P=Min(TSO2P*tcorp,1.)
 887	continue
C
c	6a. Ozone (O3) [UV and VIS bands]
c
	if(wvln.gt.1091.)goto 888
	Call G$O3U(Tref,TK,xso3,a0o3,a1o3,Apo3,AmPOL,tz3,Tcoro3,xo3,AO3)
	TO3=Min(TO3*tcoro3,1.)
	tauz3=Max(tauz3+tz3,0.)
 888	continue
c
c	6b. Ozone (O3) [IR band]
c
	if(wvln.lt.2470.)goto 889
	TO3=Min(TO3*exp(-AO3*ApO3*AmPOL),1.)
	tauz3=Max(tauz3+ApO3*AO3,0.)
 889	continue
C
c	9. Formaldehyde (CH2O)
c
	if(WVLN.gt.400.0)goto 890
	Call G$CH2O(TK,xsCH2O,atCH2O,ApCH2O,AmPOL,Tcor,TcorP)
	TCH2O=Min(TCH2O*tcor,1.)
	TCH2OP=Min(TCH2OP*tcorp,1.)
 890	continue
C
c	10. Nitrous acid (HNO2)
c
	if(wvln.lt.300.5.or.WVLN.GT.396.5)goto 891
	Call G$HNO2(TK,xsHNO2,ApHNO2,AmPOL,Tcor,TcorP)
	THNO2=Min(THNO2*tcor,1.)
	THNO2P=Min(THNO2P*tcorp,1.)
 891	continue
c	
C
c	Total gaseous absorption excluding H2O and O3
c
c	Mixed gases
c
	Tmixd=TO2*TO4*TN2*TN2O*TCO*TCO2*TCH4
      TmixdP=TO2P*TO4P*TN2P*TN2OP*TCOP*TCO2P*TCH4P
	Trace=TNO*TNO2*TNO3*THNO3*TSO2*TNH3*TBrO*TCH2O*THNO2*TClNO
      TraceP=TNOP*TNO2P*TNO3P*THNO3P*TSO2P
     2 *TNH3P*TBrOP*TCH2OP*THNO2P*TClNOP 

     	taumix=-log(Tmixd)/AmR
	tautrc=-log(Trace)/AmR	
c	if(wvl.lt.0.41)write(16,912)wvl,TNO,TNO2,TNO3,THNO3,TSO2,TNH3,
c     1 TBrO,TCH2O,THNO2,TClNO
 912	format(f6.4,1x,20(e10.5,1x))
C
c-----------------------------------------------
c
C**	AEROSOL EXTINCTION
C
	TAUA=0.
	TAUAS=0.
	TAA=1.0
	TAS=1.0
	TAT=1.0
	IF(IAER.LE.0.OR.IAER.GT.7)GOTO 33
	OMEGL=BP0(IAER)+BP1(IAER)*WVL+BP2(IAER)*WVL2+BP3(IAER)*WVL3
	IF(wvln.LE.1999.)GOTO 33
	BQ=EXP(BQ1(IAER)*(WVL-BQ2(IAER)))
	OMEGL=1.-(BQ0(IAER)*BQ)/(1.+BQ)**2
	GOTO 34
 33	CONTINUE
C
C	BRASLAU & DAVE AEROSOL MODEL C1 OR D1
C
	IF(IAER.NE.8)GOTO 35
	OMEGL=.9441-.08817*EXP(1.-3.3815E-3*wvln)
	IF(wvln.GE.2001.)OMEGL=.8569+.0436E-3*wvln
 35	CONTINUE
C
C	BRASLAU & DAVE AEROSOL MODEL C OR D
C
 	IF(IAER.EQ.9)OMEGL=1.0
 34	CONTINUE
C
	IF(BETA.GT.0.0)GOTO 37
	OMEGL=1.0
	GOTO 38
 37	TAUA=BETA/WVL**ALPHA2
	IF(wvln.LE.499.) TAUA=BETAC/(WVL**ALPHA1)
	IF(wvln.GE.1001.0.AND.IAER.EQ.8)TAUA=BETA/WVL**.825
	if(iaer.ne.1.or.iref.ne.1)goto 777
	alpha=1.1696-4.6814*wvl+12.96*wvl2
	if(wvl.eq.0.3)alpha=.93178
	if(wvl.gt.0.3.and.wvl.lt.0.337)alpha=1.443-4.6051*wvl+9.6723*wvl2
	if(wvl.eq.0.337)alpha=.989
	if(wvl.gt.0.337.and.wvl.lt.0.55)alpha=.98264+.032539*wvl
     1 -.040251*wvl2
      if(wvl.eq.0.55)alpha=.98839
      if(wvl.gt.0.55.and.wvl.lt.0.694)alpha=-32.0108+151.02*wvl-229.75
     1 *wvl2+116.83*wvl3
      if(wvl.eq.0.694)alpha=1.192
      if(wvl.gt.0.694.and.wvl.lt.1.06)alpha=-1.9669+9.576*wvl-9.4345
     1 *wvl2+3.1621*wvl3
      if(wvl.eq.1.06)alpha=1.3485
      if(wvl.gt.1.06.and.wvl.le.1.536)alpha=-.25628+3.0677*wvl-1.9011
     1 *wvl2+.41005*wvl3
      if(wvl.gt.1.536.and.wvl.le.2.0)alpha=-1.3018+3.7405*wvl-1.6633
     1 *wvl2+.25856*wvl3
      if(wvl.gt.2.0.and.wvl.le.2.25)alpha=2.1665-.40189*wvl+.057873
     1 *wvl2
      if(wvl.gt.2.25.and.wvl.le.2.5)alpha=2.1188-.35073*wvl+.044553*wvl2
      if(wvl.gt.2.5.and.wvl.le.2.7)alpha=4.3108-1.5493*wvl+.17324*wvl2
      if(wvl.gt.2.7.and.wvl.le.3.0)alpha=2.1947-.33892*wvl+.015213*wvl2
	if(wvl.gt.3.0.and.wvl.le.3.39)alpha=-2.993+3.3795*wvl-.86713*wvl2
     1 +.073101*wvl3
	if(wvl.gt.3.39.and.wvl.le.3.75)alpha=1.6801-.12171*wvl+.0068994
     1 *wvl2
	if(wvl.gt.3.75)alpha=2.0473-.27977*wvl+.022939*wvl2
	Taua=Tau5/(2.*wvl)**alpha
 777	continue
  	TAUAS=OMEGL*TAUA
	TAS=EXP(-TAUAS*AmAER)
	TAT=EXP(-TAUA*AmAER)
	TAA=TAT/TAS
 38	CONTINUE
 
c 	write(16,912)wvl,tat,alpha
C
c-----------------------------------------------
c
C	BEAM RADIATION
C
	TSCAT=TR*TAS
	TABS0=TH2O*Tmixd*Trace*TAA
	TABS=TABS0*TO3
	TDIR=TABS*TSCAT
	DIR=H0*TDIR
	DIRH=DIR*ZCOS
	H0H=H0*ZCOS
	FHTO=EXP(-FHTA0-FHTB1*(TAUZ3-2.))
c
c	corrected in 2.9.2
c
	IF(TAUZ3.le.5e-6)FHTO=1.
	IF(TAUZ3.gt.0.0.and.tauz3.LE.2.)FHTO=
     1 EXP(-FHTA1*TAUZ3-FHTA2*(TAUZ3**.95))
c
	HT=H0H
	IF(Zenit.LT.89.)GOTO 79
	HT=H0/AmR
 79	CONTINUE
 	HT=HT*TABS0*FHTO
C
c-----------------------------------------------
c
C	Diffuse radiation: 3 components
C
C
C**	1. DIFFUSE RADIATION FROM RAYLEIGH SCATTERING
C
	DRAY=0.
	FR=0.5
	FRP=0.5
	IF(TAURL.GE.EPSIR)FR=.5*EXP(-((TAURL-EPSIR)/SIGMAR)**EXPR)
	IF(TAURL.GE.EPSIRP)FRP=.5*EXP(-.1957*(TAURL-0.0648)**1.32)
 41	CONTINUE
	DRAY=HT*FR*(1.-TR**.9)
C
C	2. DIFFUSE RADIATION FROM AEROSOL SCATTERING
C
	DAER=0.
C
C	Asymmetry and forward scatterance
C
	IF(IAER.NE.8.AND.IAER.NE.9)GOTO 42
	GG=0.8042
	GOTO 43
 42	CONTINUE
	IF(IAER.LE.0.OR.IAER.GT.7)GOTO 43
	GG=AG0(IAER)+AG1(IAER)*WVL+AG2(IAER)*WVL2+AG3(IAER)
     % *WVL3+AG4(IAER)*WVL4
 43	CONTINUE
	GG=MIN(0.99,GG)
	ALG=log(1.-GG)
	AFS=ALG*(1.459+ALG*(.1595+ALG*.4129))
	BFS=ALG*(.0783+ALG*(-.3824-ALG*.5874))
	FA=1.-.5*EXP((AFS+BFS*ZCOS)*ZCOS)
	FAP=1.-.5*EXP((AFS+BFS*.6)*.6)
	SIGMAA=MAX(1.,3.5-(4.53-.82*TAUAS)*ZCOS+(8.26-6.02*TAUAS)
     % *ZCOS*ZCOS)
	SIGMAP=MAX(1.,3.5-(4.53-.82*TAUAS)*.6+(8.26-6.02*TAUAS)*.36)
	FA1=1.	
	IF(TAUAS.LE.0.2)GOTO 709
	FA1=EXP(-((TAUAS-.2)/SIGMAA)**EXPA)
	FAP=FAP*EXP(-((TAUAS-0.2)/SIGMAP)**1.072)
 709	CONTINUE
	FA=FA*FA1	
	IF(BETA.GT.0.0)DAER=HT*FA*TR*(1.-TAS)
C
C	Sky diffuse before backscattering
C
	DIF0=DRAY+DAER
C
C	3. BACKSCATTERING - reflection from ground to space and back
C
 	TRP=EXP(-1.66*TAURL)
	TAUAP=TAUA*1.66
	TASP=EXP(-OMEGL*TAUAP)
	TAAP=EXP(-(1.-OMEGL)*TAUAP)
	GAMOZ=1.
	IF(wvln.LE.379.5)GAMOZ=EXP(-1D+5*(4.8344+23.088*(AbO3+ApO3))	
     1 *(.38-WVL)**5.8)
	TTP=TmixdP*TraceP*TH2OP*TAAP
	Rhob0=Rhox
	Rhob=Rhox
	Rhod=Rhox
	Rhor=0.
	Rhoa=0.
	Rhos=0.
	Roro=0.
	Dgrnd=0.
	Glob0=Dirh+Dif0
 	If(Ialbdx.lt.0)goto 411
	rocb=0.
	if(Glob0.gt.0.)rocb=Dirh/Glob0
	Call Albdos(Ialbdx,Nwal1,Albdo1,Wvla1,Wvl,Zenit,Zcos,Rhob0,Rhob,
     1 Rhod)
 411	continue
	Rho=Max(Rhob,Rhod)
	If(TTP.le.1E-12) goto 413
	RHOR=TTP*(1.-FRP)*(TASP**.5)*(1.-TRP)*GAMOZ
	RHOA=TTP*((1.-FAP)**.9)*(1.-TASP**2)
	RHOS=RHOR+RHOA
	If(Ialbdx.ge.0)Rho=Rhob*rocb+Rhod*(1.-rocb)
	RORO=RHOD*RHOS
	DGRND=Rho*Glob0*RHOS/(1.-RORO)
 413	continue
	DIF=DIF0+DGRND
	GLOB=DIRH+DIF
C
c-----------------------------------------------
c
c	UV calculations
c
	IF(IUV.EQ.1.AND.wvln.LE.400.)CALL UVDAT(ER0,ER1,ER2,
     # ER3,ER4,DNA,PHO,ECAL,ACG,POL,SIS,PRT,SCUPH,SCUPM,wvln)
	GERY0=GLOB*ER0
	GERY1=GLOB*ER1
	GERY2=GLOB*ER2
	GERY3=GLOB*ER3
	GERY4=GLOB*ER4
	GDNA=GLOB*DNA
	GECAL=GLOB*ECAL
	GPHO=GLOB*PHO
	GACG=GLOB*ACG
	GPOL=GLOB*POL
	GSIS=GLOB*SIS
	GPRT=GLOB*PRT
	GSCUPH=GLOB*SCUPH
	GSCUPM=GLOB*SCUPM
C
c-----------------------------------------------
C
C*		PHOTON FLUX
C
	PFB=0.
	PFD=0.
	PFG=0.
	WPHT=WVL*PHOT
	PFG=GLOB*WPHT
	PFB=DIR*WPHT
	PFD=DIF*WPHT
C
c-----------------------------------------------
c
C**	CIRCUMSOLAR CORRECTION FOR A SIMULATED RADIOMETER
C
	direxp=dir
	difexp=dif
	IF(ICIRC.le.0)GOTO 77
	call Circum (Difccs,Iaer,Icirc)
c
c	Correction for the diminished aureole close to the horizon
c
	cexp=1.
	if(Zenit.le.(90.-apert))goto 76
	zexp=2.*acos((pi2-zr)/(apert*rpd))
	cexp=1.-.5*(zexp-sin(zexp))/pi
 76	continue
	difexp=Max(0.1*dif,dif-cexp*difccs*zcos)
	difcc=(Dif-Difexp)/(cexp*zcos)
	direxp=dir+difcc
 77	CONTINUE
C
c-----------------------------------------------
C
C**		CALCULATION ON INCLINED PLANES
C
C
	Dirs=Dir
	Difs=Dif
	Globs=Glob
	If(Itilt.eq.0)goto 421
	DIRS=RBN*DIR
	RDD=RD
	AerRay=0.5
	if(TauRl.gt.0.)AerRay=TauAs/TauRl
	IF(AerRay.le.0.5)RDD=RDI
	IF(AerRay.gt.0.5.and.AerRay.lt.1.5)RDD=
     2   (AerRay-.5)*RD+(1.5-AerRay)*RDI
	DIFS=RDD*DIF
	Rog=Rhog
	If(Ialbdg.lt.0)goto 429
	If(Ialbdg.ne.Ialbdx)goto 427
	Call Albdos(Ialbdg,Nwal1,Albdo1,Wvla1,Wvl,Zenit,Zcos,Rob0,Rob,Rod)
	Goto 428
 427	Continue

	Call Albdos(Ialbdg,Nwal2,Albdo2,Wvla2,Wvl,Zenit,Zcos,Rob0,Rob,Rod)
c	
 428	Continue
 	Rog=Max(Rob,Rod)
	If(TTP.le.1E-12) goto 429	
	if(Glob.gt.0.)Rog=(Rod*Dif+(Rob0+(Rob-Rob0)*Abs(cos(swa)))*Dirh)
     1 /Glob
 429	Continue
	GRNS=Rog*RG*GLOB
	GLOBS=DIRS+DIFS+GRNS
 421	continue
C
C
C	TOTAL IRRADIANCE (W/m2)	using a trapezoidal rule
C
	BNORM(IWVL)=DIR
	GLOBH(IWVL)=GLOB
	GLOBT(IWVL)=GLOBS
	DIRX(IWVL)=DIREXP
	Etspct(Iwvl)=h0
	CALL STEPS(wvln,wlmn,wlmx,DWVL)
	DIRWL=DIR*DWVL
	dirxwl=direxp*dwvl
	H0WL=H0*DWVL
	SUM0=SUM0+H0WL
	SUMBN=SUMBN+DIRWL
	SUMD=SUMD+(DIF*DWVL)
	SUMDR=SUMDR+(DRAY*DWVL)
	SUMDA=SUMDA+(DAER*DWVL)
	SUMG=SUMG+(GLOB*DWVL)
	SUMBS=SUMBS+(DIRS*DWVL)
	SUMDS=SUMDS+(DIFS*DWVL)
	SUMRS=SUMRS+(GRNS*DWVL)
	SUMGS=SUMGS+(GLOBS*DWVL)
	sumbx=sumbx+dirxwl
	sumdx=sumdx+(difexp*dwvl)
C
c-----------------------------------------------
C
C	ILLUMINANCES
C
	IF(ILLUM.EQ.0)GOTO 857
	IF(wvln.LT.380.0.OR.wvln.GT.780.)GOTO 857
	JV=Int(WVLN)-359
	if(wvln.le.400.)JV=Int(2.*(WVLN-379.45))
	XILLUM=XILLUM+vl(jv)*h0
	BILLUM=BILLUM+VL(JV)*DIR
	DILLUM=DILLUM+VL(JV)*DIF
	SILLUM=SILLUM+VL(JV)*GLOBS
	billx=billx+vl(jv)*direxp
	dillx=dillx+vl(jv)*difexp
c
C
 857	CONTINUE
C
c-----------------------------------------------
C
C	UV IRRADIANCES AND DOSES
C
	IF(IUV.NE.1)GOTO 861
	IF(wvln.GT.400.)GOTO 861
 	DWVLU=0.5
	IF(wvln.LE.280.0.OR.wvln.GE.400.)DWVLU=0.25
	SERY0=SERY0+(GERY0*DWVLU)
	SERY1=SERY1+(GERY1*DWVLU)
	SERY2=SERY2+(GERY2*DWVLU)
	SERY3=SERY3+(GERY3*DWVLU)
	SERY4=SERY4+(GERY4*DWVLU)
	SDNA=SDNA+(GDNA*DWVLU)
	SECAL=SECAL+(GECAL*DWVLU)
	SPHO=SPHO+(GPHO*DWVLU)
	SACG=SACG+(GACG*DWVLU)
	SPOL=SPOL+(GPOL*DWVLU)
	SSIS=SSIS+(GSIS*DWVLU)
	SPRT=SPRT+(GPRT*DWVLU)
	SSCUPH=SSCUPH+(GSCUPH*DWVLU)
	SSCUPM=SSCUPM+(GSCUPM*DWVLU)
	IF(wvln.GT.320.)GOTO 858
	IF(wvln.EQ.320.)DWVLU=0.25
	SUVB2=SUVB2+(GLOB*DWVLU)
	GOTO 859
 858	SUVA2=SUVA2+(GLOB*DWVLU)
 859	CONTINUE
 	IF(wvln.GT.315.)GOTO 860
	IF(wvln.EQ.315.)DWVLU=0.25
	SUVB1=SUVB1+(GLOB*DWVLU)
	GOTO 861
 860	IF(wvln.EQ.320.)DWVLU=0.5
 	SUVA1=SUVA1+(GLOB*DWVLU)
 861	CONTINUE
C
c-----------------------------------------------
c
C	OUTPUT TO FILE 16 (formatted text)
C
	NWMX=IWVL
	IF(IPRT.EQ.0)GOTO 953
	DWP=WVLN-WPMN
	KW=0.
	IF(DWP.GT.0.)KW=MOD(DWP,INTVL)
	IF(KW.NE.0.)GOTO 953
	IF(wvln.LT.WPMN.OR.wvln.GT.WPMX)GOTO 953
	IF(IPRT.ne.1.and.IPRT.ne.3)goto 426
	If(Itilt.ne.0.or.Icirc.ne.0)goto 422
	WRITE(16,128)WVLN,H0,DIR,DIRH,DIF,GLOB
 128	FORMAT(f7.1,1X,F7.3,2X,4(E11.5,1X))
     	goto 426
 422	continue
	IF(Itilt.ne.0.or.Icirc.ne.1)goto 423
	WRITE(16,120)WVLN,H0,DIR,DIF,GLOB,DIREXP,DIFEXP
 120	FORMAT(f7.1,1X,F7.3,2X,3(E11.5,1X),2X,2(E11.5,1X))
     	goto 426
 423	IF(Itilt.ne.1.or.Icirc.ne.0)goto 424
	WRITE(16,124)WVLN,H0,DIR,DIF,GLOB,DIFS,GLOBS
 124	FORMAT(f7.1,1X,F7.3,2X,3(E11.5,1X),2X,2(E11.5,1X))
 	GOTO 426
 424	CONTINUE
 	WRITE(16,125)WVLN,H0,DIR,DIF,GLOB,DIREXP,DIFS,GLOBS
 125	FORMAT(f7.1,1X,F7.3,2X,3(E11.5,1X),2X,E11.5,3X,2(E11.5,1X))
 426	continue
	IF(IPRT.ne.2.and.IPRT.ne.3)goto 953
c
c-----------------------------------------------
C
C	OUTPUT TO FILE 17 (text file in spreadsheet format)
C
	Output(1)=h0
	Output(2)=dir
	Output(3)=dif
	Output(4)=glob
	Output(5)=dirh
	Output(6)=dirs
	Output(7)=difs
	Output(8)=globs
	Output(9)=direxp
	Output(10)=difexp
	Output(11)=difcc
	Output(12)=pfg
	Output(13)=pfb
	Output(14)=pfd
	Output(15)=tr
	Output(16)=TO3
	Output(17)=Trace
	Output(18)=TH2O
	Output(19)=Tmixd
	Output(20)=tat
	Output(21)=tdir
	Output(22)=taurl
	Output(23)=tauz3
	Output(24)=tautrc
	Output(25)=tauw
	Output(26)=taumix
	Output(27)=taua
	Output(28)=omegl
	Output(29)=gg
	Output(30)=rho
	Output(31)=rog
	Output(32)=rhos
	do 457 io=1,IOTOT
	jo=IOUT(io)
	Xout(io)=Output(jo)
 457	continue
	WRITE(17,121)WVLN,(Xout(io),io=1,IOTOT)
 121	FORMAT(e10.5,32(1X,e10.5))
 953	CONTINUE
 	GOTO 15
 999	CONTINUE
C
C***	END OF SPECTRAL CALCULATIONS
C
c-----------------------------------------------
c-----------------------------------------------
c
	SUMB=SUMBN*ZCOS
C
c
c	Luminous efficacy
C
	IF(ILLUM.EQ.0)GOTO 960
	XILLUM=.683*XILLUM
	BILLUM=.683*BILLUM
	DILLUM=.683*DILLUM
	GILLUM=BILLUM*ZCOS+DILLUM
	SILLUM=.683*SILLUM
	BILLX=.683*BILLX
	DILLX=.683*DILLX
	EFF0=1000.*XILLUM/ESCC
	EFFB=0.
	EFFD=0.
	EFFG=0.
	EFFS=0.
	EFFBX=0.
	EFFDX=0.
	IF(SUMBN.GT.0.)EFFB=1000.*BILLUM/SUMBN
	IF(SUMD.GT.0.)EFFD=1000.*DILLUM/SUMD
	IF(SUMG.GT.0.)EFFG=1000.*GILLUM/SUMG
	IF(SUMGS.GT.0.)EFFS=1000.*SILLUM/SUMGS
	IF(SUMBX.GT.0.)EFFBX=1000.*BILLX/SUMBX
	IF(SUMDX.GT.0.)EFFDX=1000.*DILLX/SUMDX
 960	CONTINUE
 968	continue
C
c-----------------------------------------------
C
c	UV dose & index
C
C	UV DOSE IN MED/hour TO SIMULATE A ROBERTSON-BERGER MEASUREMENT
C	(1 MED = 210 J/m2 or 1 MED/HOUR = 58.33E-3 W/m2 with the
C	CIE Erythema action curve convolved to the irradiance)
C
	DOSE=SERY0/.05833
C
c UV index, defined as 40*Erythemally weighted irradiance
c
	UVindx=Sery0*40.
c
c-----------------------------------------------
c
c	Daily calculations for Imass=4
c
	if(imass.ne.4)goto 894
	Hbnx=Hbnx+Sumbx
	Hbhx=Hbhx+(Sumbx*zcos)
	Hdx=Hdx+Sumdx
	Hglob=Hglob+Sumg
	Hglobs=Hglobs+Sumgs
	if(iUV.eq.1)Hdose=Hdose+dose
	if(illum.ne.1)goto 899
	Hiext=xillum
	Hibx=Hibx+billx
	Hidx=Hidx+dillx
	Hig=Hig+gillum
	His=His+sillum
	goto 899
 894	continue
c
c-----------------------------------------------
c-----------------------------------------------
c
c	Print results
c
c-----------------------------------------------
C	
 	WRITE(16,122) wlmn,wlmx,NWMX,SUM0,SUMBN,sumbn/sum0,SUMB,SUMD,
     %   SUMG
 122	FORMAT(/,'Wavelength Range = '
     % ,f6.1,' to ',f6.1,' nm ;',3X,'Number of Wavelengths = ',I5,
     % //,'*** BROADBAND IRRADIANCES (W/m2):',//,'* DIRECT BEAM AT ',
     3 'NORMAL INCIDENCE:',/,2x,'Extraterrestrial = ',F7.2,3X,
     % 'Terrestrial = ',F7.2,3x,'Atmospheric Transmittance = ',f6.4,//,
     2 '* FOR THE HORIZONTAL PLANE:',/,2x,
     $ 'Direct Beam = ',F7.2,'   Diffuse = ',F6.2,'   Global = ',F7.2)
	WRITE(16,135)SUMDR,SUMDA,(SUMD-(SUMDR+SUMDA))
 135	FORMAT('  Diffuse irradiance components:',/,'  Rayleigh scatt'
     2 ,'ering = ',F6.2,'   Aerosol scattering = ',F6.2,'   Back',
     3 'scattering = ',F6.2,/)
C
     	IF(ITILT.GT.0)WRITE(16,123)SUMBS,SUMDS,SUMRS,SUMGS
 123	FORMAT( '* FOR THE TILTED PLANE: ',/,'  Direct Beam = ',F7.2,
     % ' Sky Diffuse = ',F6.2,'   Ground Reflected = ',F6.2,
     # '   Global = ',F7.2,/)
	IF(ICIRC.GT.0)WRITE(16,137)SUMBX,SUMDX,sumg
 137	FORMAT('* EXPERIMENTAL (WITH CIRCUMSOLAR CORRECTION):',/,2x,
     # 'Direct Beam, Normal Incidence = ',f7.2,'   Diffuse Horizontal ',
     2 '= ',F6.2,'   Global Horizontal = ',F7.2,/)
C
     	IF(ILLUM.NE.0)WRITE(16,188)CIEYr,XILLUM,BILLUM,DILLUM,GILLUM,
     2  SILLUM
	IF(ILLUM.NE.0.AND.ICIRC.EQ.1)WRITE(16,189)BILLX,DILLX
	IF(ILLUM.EQ.2)WRITE(16,180)EFF0,EFFB,EFFD,EFFG,EFFS
    	IF(Abs(ILLUM).EQ.2.AND.ICIRC.EQ.1)WRITE(16,181)EFFBX,EFFDX
 188	FORMAT('*** ILLUMINANCES (klux) obtained with the Vlambda curve'
     2 ,' from CIE 19',i2,':',/,' E.T. = ',F6.2,
     %'  BEAM NORMAL = ',F6.2,' DIFFUSE = ',F7.2
     $,' GLOBAL = ',F7.2,' GLOBAL TILT = ',F7.2,/)
 180	FORMAT('*** LUMINOUS EFFICACY',
     &' (lm/W):',/,' E.T. = ',F6.2,'  BEAM = ',F7.3, ' DIFFUSE = ',F7.3
     %,'   GLOBAL = ',F7.3,'   GLOBAL TILT = ',F7.3,/)
 189	FORMAT('    ILLUMINANCES WITH CIRCUMSOLAR CORRECTION (klux): ',/
     &,'  BEAM NORMAL = ',F6.2,'   DIFFUSE = ',F7.2,/)
 181	FORMAT('   LUMINOUS EFFICACY WITH CIRCUMSOLAR CORRECTION (lm/W)'
     &,':',/,'  BEAM = ',F7.3, '   DIFFUSE = ',F7.3,/)
     	IF(IUV.EQ.1)WRITE(16,143)SUVA1,SUVB1,SUVA2,SUVB2,SERY0,SERY1,
     @ SERY2,SERY4,SDNA,SPHO,SACG,SECAL,SPOL,SSIS,SPRT,SSCUPH,
     & SSCUPM
     	IF(IUV.EQ.1)WRITE(16,144)DOSE,UVindx
 143	FORMAT(/,'*** UV IRRADIANCES (W/m2):',//,' TOTAL UV-A IRRADIANC'
     $,'E (315-400 nm) = ',F9.5,/,' TOTAL UV-B IRRADIANCE (280-315 nm'
     #,') = ',F8.5,//,' TOTAL UV-A IRRADIANCE (320-400 nm) = ',F9.5,/,
     #' TOTAL UV-B IRRADIANCE (280-320 nm) = ',F8.5,//,' ACTION-WEIGHT'
     %,'ED DOSE RATES ACCORDING TO SELECTED ACTION CURVES',//,'   ERYT'
     %,'HEMAL C.I.E. (McKinley & Diffey, 1987) = ',E10.4,/,'   ERYTHE',
     %'MAL from Green et al. (1974) = ',E10.4,/,'   ERYTHEMAL from ',
     # 'Green et al. (1975) = ',E10.4,/,'   ERYTHEMAL from ',
     #'Diffey (1982) modified by Bjrn (1989) = ',E10.4,/,'   DNA DAMA
     %GE from Setlow (1974) = ',E10.4,/,'   PHOTOSYNTHESIS INHIBITION' 
     $,' from Caldwell et al. (1986) = ',E10.4,/,'   ACGIH SAFETY ',
     %'SPECTRUM from Wester (1981) = ',E10.4,/,'   BIOLOGICAL ACTION '
     #,'from Caldwell (1971) and Green (1974) = ',E10.4,/,'   POLYCHRO'
     %,'MATIC ACTION FOR HIGHER PLANTS from Caldwell et al. (1986) = ',
     #E10.4,/,'   SYSTEMIC IMMUNOSUPPRESSION from deFabo et al. (1990)
     % = ',E10.4,/,'   DNA TO PROTEIN CROSSLINKS from Peak & Peak ',
     %'(1986) = ',E10.4,/,'   SKIN CARCINOGENESIS from de Gruijl & Van'
     &,' der Leun (1994) = ',E10.4,' (humans)    ',E10.4,' (mice)',//)
 144	FORMAT('   DOSE RATE IN MED/h from an ideal Robertson-Berger',
     % ' instrument = ',E10.4,/,'   UV Index = ',f7.3,//)
C
C-----------------------------------
c
c	Postprocessor: scan and smooth irradiance results if ISCAN=1
c
	IF(ISCAN.EQ.0)GOTO 898
	filter='Gaussian'
	if(ifilt.eq.0)FILTER='Triangular'
	WRITE(18,155)FWHM,step,filter
 155	FORMAT(' SMOOTHED RESULTS TO SIMULATE A ',F5.2,' nm FWHM',
     # ' INSTRUMENT AND A WAVELENGTH STEP OF ',f4.1,' nm,',/,
     2 ' Shape selected: ',A10)
      WRITE(18,193)
 193	FORMAT(' WVLGTH',5X,'SPECTRUM ','  BEAM NORM','   BEAM NORM+',
     2 '  GLOB HOR','    GLOB TILT',/)
     	IF(IFILT.NE.1)GOTO 91
	sigma2=fwhm*fwhm/5.5451774
	fk=fwhm*2.
	CALL ScanG(step,FWHM,fk,sigma2,Nwmx)
 	GOTO 92
 91	CONTINUE
 	fk=fwhm
 	CALL ScanT(step,FWHM,fk,Nwmx)
 92	CONTINUE
C
     	GOTO 898
 914	CONTINUE
 	CLOSE (UNIT=14,STATUS='KEEP')
	CLOSE (UNIT=15,STATUS='KEEP')
	CLOSE (UNIT=16,STATUS='KEEP')
	IF(IPRT.ge.2)CLOSE (UNIT=17,STATUS='KEEP')
	IF(Iscan.eq.1)CLOSE (UNIT=18,STATUS='KEEP')
	CLOSE (UNIT=20,STATUS='KEEP')
      IF(w.gt.0.)CLOSE (UNIT=21,STATUS='KEEP')
      CLOSE (UNIT=22,STATUS='KEEP')
	IF(AbO3.gt.0.)CLOSE (UNIT=23,STATUS='KEEP')
	IF(AbO3.gt.0.)CLOSE (UNIT=24,STATUS='KEEP')
	CLOSE (UNIT=25,STATUS='KEEP')
	CLOSE (UNIT=26,STATUS='KEEP')
	CLOSE (UNIT=27,STATUS='KEEP')
	CLOSE (UNIT=28,STATUS='KEEP')
	CLOSE (UNIT=29,STATUS='KEEP')
	CLOSE (UNIT=30,STATUS='KEEP')
	CLOSE (UNIT=31,STATUS='KEEP')
	CLOSE (UNIT=32,STATUS='KEEP')
	CLOSE (UNIT=33,STATUS='KEEP')
	CLOSE (UNIT=34,STATUS='KEEP')
	CLOSE (UNIT=35,STATUS='KEEP')
	CLOSE (UNIT=36,STATUS='KEEP')
	CLOSE (UNIT=37,STATUS='KEEP')
	CLOSE (UNIT=38,STATUS='KEEP')
	CLOSE (UNIT=39,STATUS='KEEP')
	CLOSE (UNIT=40,STATUS='KEEP')
	CLOSE (UNIT=41,STATUS='KEEP')
	STOP
	END
c
c
c-----------------------------------------------
c	SUBROUTINES
c-----------------------------------------------
c
	Subroutine ALBCHK(N,Name,Wvla,Albdo,Wlmin,Wlmax)
c
c	Sends a Warning message if the reflectance data range is less
c	than the simulated spectrum range.
c
	Real Wvla(2002),Albdo(2002),Minalb,Maxalb
	Character*24 Name 
	
	Minalb=Albdo(1)
	Maxalb=Albdo(N)
	dwvl=.0005
	if(Wlmin.gt.0.4)dwvl=.001
	if(Wlmin.gt.1.702)dwvl=.005
	wvl1=Wvla(1)-dwvl
	wvln=Wvla(N)+dwvl
	If(wvl1.gt.Wlmin.or.Wvla(N).lt.Wlmax)Write(16,195)Name,
     2  Wvla(1),Wvla(N),Wlmin,Wlmax,Minalb,Wvla(1),Maxalb,Wvla(N)
 195	Format('**WARNING! Ground reflectance data for ',
     2  A24,/,' extend only from ',f6.4,' to ',
     3  f6.4,' m,',/,' whereas the wavelength limits for this run are '
     4 ,f6.4,' and ',f6.4,' m.',/,' Consequently, reflectance is ',
     5 'fixed at ',F5.3,' below ',f6.4,' m and at ',F5.3,' above ',
     6 f6.4,' m.',//)
	Return
	End
c
c
c	
	Subroutine ALBDAT(Ialbd,Ntot,Name,Lamber,Wvla,Albd)
c
c	Reads the selected albedo data file
c
	Character*24 Name, Lamber
	Real Wvla(2002),Albd(2002)
	
c	Nfile=Max(19,18+Ialbd)
 3	If(Ialbd.ne.3)goto 4
 	Open (UNIT=20,FILE='SNOW.DAT',STATUS='OLD')
	Name='FRESH_SNOW'
	Goto 300
 4	If(Ialbd.ne.4)goto 5
	Open (UNIT=20,FILE='NEVE.DAT',STATUS='OLD')
	Name='MOUNTAIN_NEVE'
	Goto 300
 5	If(Ialbd.ne.5)goto 6
	Open (UNIT=20,FILE='BASALT.DAT',STATUS='OLD')
	Name='BASALT_ROCK'
	Goto 300
 6	If(Ialbd.ne.6)goto 7
	Open (UNIT=20,FILE='DRY_SAND.DAT',STATUS='OLD')
	Name='DRY_SAND'
	Goto 300
 7	If(Ialbd.ne.7)goto 8
	Open (UNIT=20,FILE='WITESAND.DAT',STATUS='OLD')
	Name='WHITE_SANDS'
	Goto 300
 8	If(Ialbd.ne.8)goto 9
	Open (UNIT=20,FILE='SOIL.DAT',STATUS='OLD')
	Name='SOIL'
	Goto 300
 9	If(Ialbd.ne.9)goto 10
	Open (UNIT=20,FILE='DRYCLAY.DAT',STATUS='OLD')
	Name='DRY_CLAY_SOIL'
	Goto 300
 10	If(Ialbd.ne.10)goto 11
	Open (UNIT=20,FILE='WETCLAY.DAT',STATUS='OLD')
	Name='WET_CLAY_SOIL'
	Goto 300
 11	If(Ialbd.ne.11)goto 12
	Open (UNIT=20,FILE='ALFALFA.DAT',STATUS='OLD')
	Name='ALFALFA'
	Goto 300
 12	If(Ialbd.ne.12)goto 13
 	Open (UNIT=20,FILE='GRASS.DAT',STATUS='OLD')
	Name='GRASS'
	Goto 300
 13	If(Ialbd.ne.13)goto 14
 	Open (UNIT=20,FILE='RYEGRASS.DAT',STATUS='OLD')
	Name='RYE_GRASS'
	Goto 300
 14	If(Ialbd.ne.14)goto 15
 	Open (UNIT=20,FILE='MEADOW1.DAT',STATUS='OLD')
	Name='ALPINE_MEADOW'
	Goto 300
 15	If(Ialbd.ne.15)goto 16
 	Open (UNIT=20,FILE='MEADOW2.DAT',STATUS='OLD')
	Name='LUSH_MEADOW'
	Goto 300
 16	If(Ialbd.ne.16)goto 17
 	Open (UNIT=20,FILE='WHEAT.DAT',STATUS='OLD')
	Name='WHEAT'
	Goto 300
 17	If(Ialbd.ne.17)goto 18
 	Open (UNIT=20,FILE='PINETREE.DAT',STATUS='OLD')
	Name='PONDEROSA_PINE_TREE'
	Goto 300
 18	If(Ialbd.ne.18)goto 19
 	Open (UNIT=20,FILE='CONCRETE.DAT',STATUS='OLD')
	Name='CONCRETE'
	Goto 300
 19	If(Ialbd.ne.19)goto 20
 	Open (UNIT=20,FILE='BlckLoam.dat',STATUS='OLD')
	Name='BLACK_LOAM'
	Goto 300
 20	If(Ialbd.ne.20)goto 21
 	Open (UNIT=20,FILE='BrwnLoam.dat',STATUS='OLD')
	Name='BROWN_SANDY_LOAM'
	Goto 300
 21	If(Ialbd.ne.21)goto 22
 	Open (UNIT=20,FILE='BrwnSand.dat',STATUS='OLD')
	Name='BROWN_LOAMY_FINE_SAND'
	Goto 300
 22	If(Ialbd.ne.22)goto 23
 	Open (UNIT=20,FILE='Conifers.dat',STATUS='OLD')
	Name='CONIFER_TREES'
	Goto 300
 23	If(Ialbd.ne.23)goto 24
 	Open (UNIT=20,FILE='DarkLoam.dat',STATUS='OLD')
	Name='BROWN_SILT_LOAM'
	Goto 300
 24	If(Ialbd.ne.24)goto 25
 	Open (UNIT=20,FILE='DarkSand.dat',STATUS='OLD')
	Name='BROWN_LOAMY_SAND'
	Goto 300
 25	If(Ialbd.ne.25)goto 26
 	Open (UNIT=20,FILE='Decidous.dat',STATUS='OLD')
	Name='DECIDUOUS_TREES'
	Goto 300
 26	If(Ialbd.ne.26)goto 27
 	Open (UNIT=20,FILE='DryGrass.dat',STATUS='OLD')
	Name='DRY_GRASS'
	Goto 300
 27	If(Ialbd.ne.27)goto 28
 	Open (UNIT=20,FILE='DuneSand.dat',STATUS='OLD')
	Name='WHITE_DUNE_SAND'
	Goto 300
 28	If(Ialbd.ne.28)goto 29
 	Open (UNIT=20,FILE='FineSnow.dat',STATUS='OLD')
	Name='FINE_SNOW'
	Goto 300
 29	If(Ialbd.ne.29)goto 30
 	Open (UNIT=20,FILE='GrnGrass.dat',STATUS='OLD')
	Name='GREEN_GRASS'
	Goto 300
 30	If(Ialbd.ne.30)goto 31
 	Open (UNIT=20,FILE='GrnlSnow.dat',STATUS='OLD')
	Name='GRANULAR_SNOW'
	Goto 300
 31	If(Ialbd.ne.31)goto 32
 	Open (UNIT=20,FILE='LiteClay.dat',STATUS='OLD')
	Name='LIGHT_BROWN_CLAY'
	Goto 300
 32	If(Ialbd.ne.32)goto 33
 	Open (UNIT=20,FILE='LiteLoam.dat',STATUS='OLD')
	Name='LIGHT_BROWN_LOAM'
	Goto 300
 33	If(Ialbd.ne.33)goto 34
 	Open (UNIT=20,FILE='LiteSand.dat',STATUS='OLD')
	Name='LIGHT_BROWN_LOAMY_SAND'
	Goto 300
 34	If(Ialbd.ne.34)goto 35
 	Open (UNIT=20,FILE='PaleLoam.dat',STATUS='OLD')
	Name='PALE_BROWN_LOAM'
	Goto 300
 35	If(Ialbd.ne.35)goto 36
 	Open (UNIT=20,FILE='SeaWater.dat',STATUS='OLD')
	Name='SEA_WATER'
	Goto 300
 36	If(Ialbd.ne.36)goto 37
 	Open (UNIT=20,FILE='SolidIce.dat',STATUS='OLD')
	Name='SOLID_ICE'
	Goto 300
 37	If(Ialbd.ne.37)goto 38
 	Open (UNIT=20,FILE='Dry_Soil.dat',STATUS='OLD')
	Name='DRY_SOIL'
	Goto 300
 38	If(Ialbd.ne.38)goto 2
 	Open (UNIT=20,FILE='LiteSoil.dat',STATUS='OLD')
	Name='LIGHT_SANDY_SOIL'
	Goto 300
c	
 2	If(Ialbd.ne.2)goto 1
 	Ntot=2
	Lamber='NON_LAMBERTIAN'
	Wvla(1)=280.
	Albd(1)=.035
	Name='WATER'
	Return
 1	If(Ialbd.LE.1)Open (UNIT=20,FILE='ALBEDO.DAT',STATUS='OLD')
     	Name='USER_DEFINED'
 300	Continue
     	Ial=1
 371	Read(20,*,End=370)Wvla(Ial),Albd(Ial)
 	Ial=Ial+1
	Goto 371
 370	Continue
 	Ntot=Ial-1
	if(Ntot.gt.2002)write(16,911)Ialbd,Ntot
 911	format(' Error in albedo file # ',i2,': Number of data rows is ',
     1  i8,/,' but should be <= 2002',/)
	Lamber='NON_LAMBERTIAN'
	If(Ialbd.le.0)Lamber='LAMBERTIAN'
	Close (Unit=20,status='keep')
	Return
	End
C
C
C
	Subroutine ALBDOS (Ialbd,Nwal,Albdo,Wvla,Wvl,Z,Zcos,Rhob0,
     2   Rhob,Rhod)
c
c	Calculates and/or interpolates spectral albedo and provides
c	non-Lambertian reflectances for direct and diffuse radiation
c
	Double Precision Z
	Real Wvla(2002), Albdo(2002)
c
	If(Ialbd.eq.2)goto 734
c
c	Interpolation in wavelength for albedo data
c
	Do 730 Ial=1,Nwal
	If(Wvla(Ial).ne.Wvl)goto 731
	Rhox=Albdo(Ial)
	Goto 730
 731	If(Wvl.ge.Wvla(1))goto 732
	Rhox=Albdo(1)
	Goto 730
 732	If(Wvl.le.Wvla(Nwal))Goto 733
 	Rhox=Albdo(Nwal)
 	Goto 730
 733	Continue
 	If(Wvla(Ial).lt.Wvl.and.Wvla(Ial+1).gt.Wvl)Call Interp(1,
     2  Wvla(Ial),Wvla(Ial+1),Wvl,Albdo(Ial),Albdo(Ial+1),Rhox)
 730	Continue
c
 	Rhod=Rhox
	Rhob0=Rhox
	Rhob=Rhox
c
C	Non-Lambertian reflection
c
	If(Ialbd.le.0)goto 738
	If(Ialbd.ne.3.and.Ialbd.ne.4.and.Ialbd.ne.28.and.Ialbd.ne.30)
     1 goto 741
c
c	Fresh snow case, based on Larsen & Barkstrom 1977
c
	Rhod=Rhob0*.939
	Rhob=Rhob0*(1.-.176*Zcos)/.94
	Goto 738
 741	continue
c
c	All other natural albedos, except water, based on the 
c	"land albedo" formula of Larsen & Barkstrom
c
	Rhob=Rhob0/.35
	Rhod=Rhob0*1.167
	If(Zcos.gt.1.0E-6)Rhob=Rhob*(1.-Zcos*log(1.+1./Zcos))
	Goto 738
c
c	Water albedo, as in oceans, fitted from Fresnel formula used with
c	spectral refractive indices of air and water, and taking the
c	 underlying reflectance into account
c
 734	Continue
 	Wvl2=Wvl*Wvl
	Wvl3=Wvl2*Wvl
 	Rhod=.0803-.00365*Wvl
	Rhob0=.04059-.015565*Wvl+.013033*Wvl2-.0036053*Wvl3
 	If(Wvl.gt.2.8)Rhob0=-4.264+3.6959*Wvl-1.0508*Wvl2+.099003*Wvl3
	Rhob=Rhob0*(1.+(.001209-.00010748*Wvl)*exp((.11087+.0017729*Wvl)
     2  *Z))
 738	Continue
 	Rhob0=Min(Rhob0,1.)
	Rhob=Min(Rhob,1.)
	Rhod=Min(Rhod,1.)
	
	Return
	End
c
c
c
	FUNCTION AMZ(X)
C
c	New coefficients in 2.9
c
	Double Precision X,XR,Xcos
	XR=X*0.017453293
	XCOS=COS(XR)
	AMZ=1./(XCOS+.48353*(X**.095846)*(96.741-X)**(-1.754))
	RETURN
	END
C                                                                                                                    
C                                                                     
C
	SUBROUTINE RefAtm(PR,T,T0,TS,RH,W,Z,Iref)
C
	REAL PREF(10,5),TREF(10,5),TSRF(10,5),RHRF(10,5)
	REAL WREF(10,5),ZREF(5)
	
	DATA ZREF/0.,1.,2.,3.,4./
	DATA (PREF(I,1),I=1,10)/1013.25,1013.25,1018.,1010.,1013.,1013.,
     % 1013.5,1021.,1012.5,1013.5/
     	DATA (PREF(I,2),I=1,10)/898.8,902.,897.3,896.,887.8,904.,
     % 904.6,906.4,895.,884.1/
     	DATA (PREF(I,3),I=1,10)/795.,802.,789.7,792.9,777.5,805.,
     % 805.1,803.5,790.2,772.1/
     	DATA (PREF(I,4),I=1,10)/701.2,710.,693.8,700.,679.8,715.,
     % 714.8,710.7,696.7,672.7/
     	DATA (PREF(I,5),I=1,10)/616.6,628.,608.1,616.,593.2,633.,
     % 633.1,626.8,612.5,584.3/
C
     	DATA (RHRF(I,1),I=1,10)/45.45,75.74,76.97,74.93,80.43,74.94,
     % 80.,80.,85.,80./
     	DATA (RHRF(I,2),I=1,10)/48.71,65.55,70.4,69.77,69.25,72.29,
     % 65.,70.,75.,65./
     	DATA (RHRF(I,3),I=1,10)/51.76,54.76,65.36,69.68,69.88,74.18,
     % 60.,50.,65.,60./
     	DATA (RHRF(I,4),I=1,10)/50.6,44.96,56.65,64.95,65.6,47.84,
     % 60.,45.,60.,55./
     	DATA (RHRF(I,5),I=1,10)/49.97,38.82,49.83,60.34,60.37,34.65,
     % 50.,35.,55.,50./
C     	
     	DATA (TREF(I,1),I=1,10)/288.2,294.2,272.2,287.2,257.2,299.7,
     % 301.15,287.15,278.15,249.15/
     	DATA (TREF(I,2),I=1,10)/281.7,289.7,268.7,281.7,259.1,293.7,
     % 293.65,284.15,275.55,252.15/
     	DATA (TREF(I,3),I=1,10)/275.2,285.2,265.2,276.3,255.9,287.7,
     % 288.15,281.15,272.95,250.9/
     	DATA (TREF(I,4),I=1,10)/268.7,279.2,261.7,270.9,252.7,283.7,
     % 282.65,274.65,268.4,245.4/
     	DATA (TREF(I,5),I=1,10)/262.2,273.2,255.7,265.5,247.7,277.0,
     % 277.15,268.15,261.9,239.9/

C     	
	DATA (TSRF(I,1),I=1,10)/225.4,232.1,220.6,233.6,217.4,229.7,
     % 224.5,221.2,235.7,213.0/
     	DATA (TSRF(I,2),I=1,10)/223.4,229.7,218.7,231.7,216.1,226.9,
     % 221.5,218.3,232.9,210.4/
     	DATA (TSRF(I,3),I=1,10)/221.3,227.3,217.0,229.6,214.8,224.3,
     % 218.8,215.7,230.3,208.1/
     	DATA (TSRF(I,4),I=1,10)/219.4,224.9,215.4,227.5,213.5,221.8,
     % 216.4,213.4,228.0,206.0/
     	DATA (TSRF(I,5),I=1,10)/217.7,222.4,213.9,225.4,212.1,219.6,
     % 214.1,211.2,225.9,204.1/
C
     	DATA (WREF(I,1),I=1,10)/1.41642,2.92232,.8517,2.08123,0.41612,
     % 4.11467,4.219,2.101,1.479,0.217/
     	DATA (WREF(I,2),I=1,10)/0.91753,1.77628,0.55552,1.33757,0.29744,
     % 2.54035,2.593,1.218,0.965,0.15/
     	DATA (WREF(I,3),I=1,10)/0.56711,1.0301,0.3428,0.83544,0.19098,
     % 1.43902,1.695,0.709,0.615,0.093/
     	DATA (WREF(I,4),I=1,10)/0.33526,0.57902,0.19473,0.49507,0.11056,
     % 0.75316,0.998,0.369,0.343,0.051/
     	DATA (WREF(I,5),I=1,10)/0.19299,0.32579,0.10355,0.27876,0.05663,
     % 0.42402,0.604,0.209,0.195,0.029/
C
	INTRP=1
	K=Iref
	DO 1 IZ=1,5
	IF(Z.NE.ZREF(IZ))GOTO 1
	IZ1=IZ
	INTRP=0
 1	CONTINUE
 	T0=TREF(K,1)
 	IF(INTRP.EQ.1)GOTO 2
	J=IZ1
	T=TREF(K,J)
	PR=PREF(K,J)
	TS=TSRF(K,J)
	RH=RHRF(K,J)
	W=WREF(K,J)
	GOTO 99
 2	I=INT(Z)+1
 	IF(I.LE.2)I=2
	IF(I.GE.3)I=3
	P=Z-I+1
	Call Lagrge(TREF(K,I+2),TREF(K,I+1),TREF(K,I),TREF(K,I-1),P,T)
	Call Lagrge(PREF(K,I+2),PREF(K,I+1),PREF(K,I),PREF(K,I-1),P,PR)
	Call Lagrge(TSRF(K,I+2),TSRF(K,I+1),TSRF(K,I),TSRF(K,I-1),P,TS)
	Call Lagrge(RHRF(K,I+2),RHRF(K,I+1),RHRF(K,I),RHRF(K,I-1),P,RH)
	Call Lagrge(WREF(K,I+2),WREF(K,I+1),WREF(K,I),WREF(K,I-1),P,W)
 99	CONTINUE
	RETURN
 	END
c
c
	Subroutine Circum (Ecircl,Jaer,Icirc)
c
c	Circumsolar calculations based on typical aerosol phase functions
c	and an improved single-scattering approximation for the aureole
c	radiance. The original data for the SRA aerosol phase functions
c	were supplied by Maria Putsay, Hungarian Met. Service (1995).
c
	REAL WVLref(5),RHref(4),PHFNA(8)
	Double precision Ecircl,SKY,Ebnl
	Character*64 Aeros
	Common /Solar3/Ebnl,Aeros,Tauasl,Taurl,Rognd,Degrad,pi,pi4,AmR,
     2   WVL,wvln,nx,Znr,va,vb,RH

	Data Wvlref /.3,.55,.694,1.06,1.536/
	Data RHref /0.,70.,80.,99./

	PHFNR0=1.4794/pi4
C
C	SOURCE OF THE BASIC DATA POINTS FOR THE AEROSOL PHASE FUNCTIONS
C		[Fits = f(scatt. angle, wvlgth) by C. Gueymard]
C
C	JAER 		AEROS                         SOURCE
C     ______      _____________________         ____________
C	1		S&F_RURAL				MODTRAN2
C	2		S&F_URBAN					"
C	3		S&F_MARIT					"
C	4		S&F_TROPO					"
C	5	  	SRA_CONTL				Putsay 1995
C	6		SRA_URBAN					"
C	7 		SRA_MARIT					"
C	8	  	B&D_C  (HAZE L)   		Lenoble 1985
C	9	  	B&D_C1 (HAZE L)   			"

	ja=jaer
	if(jaer.eq.9)ja=8
	if(jaer.eq.0)ja=5
	if(ja.le.4)Call Phase1(wvl,RH,ja,IRH0,NN,Iwv0,Inter1,Inter2)
	if(ja.ge.5.and.ja.le.7)Call Phase2(wvl,ja,A0,A1,A2,A3,B0,B1,B2)
c
	TAUTSL=TAURL+TAUASL
	TAURM=1.38*TAUTSL*TAUTSL
	TAUGM=ROGND*(TAURL+TAURM)
	ECIRCL=0.0D+00
c
c	Main loop for x, the incremental scattering angle
c
	DO 20 ix=1,nx
	x=.1*(ix-1)
	x2=x*x
	DX=.1*DEGRAD
	XR=X*DEGRAD
	SIN2X=SIN(2.*XR)
	PHFNR=(.76032+.71904*(COS(XR)**2))/pi4
	if(ja.gt.4)goto 25
c	
c	Call PhF1 to pick the correct Shettle & Fenn phase function, then
c	interpolate in wavelength and/or humidity if necessary
c
	PF11=PhF1(NN,IWV0,x)
	If(Inter2.ne.0)PF12=PhF1(NN,IWV0+1,x)
	If(Inter1.ne.0)PF21=PhF1(NN+1,IWV0,x)
	If(Inter1.ne.0.and.Inter2.ne.0)PF22=PhF1(NN+1,IWV0+1,x)
	PF=PF11
	PF1=0.
	PF2=0.
	If(Inter1.eq.0.and.Inter2.eq.0)goto 49
	If(Inter2.eq.0)goto 41
	Call Interp(2,Wvlref(Iwv0),Wvlref(Iwv0+1),Wvl,PF11,PF12,PF2)
     	PF=PF2
 41	continue
 	If(Inter1.eq.0)goto 49
	Call Interp(1,RHref(Irh0),RHref(Irh0+1),RH,PF11,PF21,PF1)
	PF=PF1
	If(PF1.le.0.0.or.PF2.le.0.0)goto 49
	Call Interp(2,Wvlref(Iwv0),Wvlref(Iwv0+1),Wvl,PF21,PF22,PF3)
	Call Interp(1,RHref(Irh0),RHref(Irh0+1),RH,PF2,PF3,PF)
 49 	continue
c
	PHFNA(ja)=PF
 	goto 24
 25	continue
c
	IF(JA.GT.7)GOTO 23
	IF(X.GT.1.)GOTO 22
	PHFNA(JA)=B0+B1*X+B2*X2
	GOTO 24
 22	CONTINUE
 	XLN=log(X+1.)
	XLN2=XLN*XLN
	PHFNA(JA)=EXP(A0+A1*XLN+A2*XLN2+A3*XLN2*XLN)
	GOTO 24
 23	CONTINUE
 	PHFNA(8)=(2.4148+.59238*X-.032609*X2)/(1.+.23295*X)
 24	CONTINUE
C
C	Global sky scattering function
C
	PHFNT=(TAURL+TAURM)*PHFNR+TAUGM*PHFNR0+TAUASL*PHFNA(JA)
C
C	SKY RADIANCE AT DISTANCE X DEGREES FROM THE SUN'S CENTER ALONG
C		THE ALMUCANTAR (W/m2 nm sr)
C
	SKY=EBNL*AmR*PHFNT
C
C	NUMERICAL INTEGRATION (SIMPSON'S RULE) TO OBTAIN THE CIRCUMSOLAR
C	   SPECTRAL IRRADIANCE WITHIN THE APERTURE ANGLE
C	   and taking the geometric penumbra function into account
C	   if the radiometer's geometry (slope and limit angles) is known
C
	DXI=2.*DX
	IF(MOD(ix,2).EQ.0)DXI=4.*DX
	IF(ix.EQ.1.OR.ix.EQ.nx)DXI=DX
	Penumb=1.
	if(Icirc.lt.2.or.xr.le.Znr)goto 21
	Z1=.5*vb*tan(xr)
	Z2=.5*(va*va - 1.)/(vb*tan(xr))
	vu=2.*acos(Z1-Z2)
	vl=2.*acos((Z1+Z2)/va)
	Penumb=2.*(va*va*(vl-sin(vl))+vu-sin(vu))/pi4
 21 	continue
	ECIRCL=ECIRCL+SKY*Penumb*SIN2X*DXI*PI
 20	CONTINUE
c 
 	ECIRCL=ECIRCL/3.
c
 999	CONTINUE
 	Return
	END
c
c
	Subroutine G$CH4(ACH4,AbCH4,AmCH4,TCH4,TCH4P)
C
	TCH4=exp(-(ACH4*AbCH4*AmCH4))
	TCH4P=exp(-(ACH4*AbCH4*1.66))
 803	continue
 	return
	end
c
c
	Subroutine G$CH2O(T,xsCH2O,atCH2O,AbCH2O,AmCH2O,TCH2O,TCH2OP)
C
	Double Precision NLosch
c	
	Common /Number/ NLosch
c
	ACH2O=(xsCH2O+atCH2O*(T-293.))*NLosch
	TCH2O=exp(-ACH2O*AbCH2O*AmCH2O)
	TCH2OP=exp(-ACH2O*AbCH2O*1.66)
 	return
	end
c
c
	Subroutine G$CO(ACO,AbCO,AmCO,TCO,TCOP)
C
	TCO=exp(-ACO*AbCO*AmCO)
	TCOP=exp(-ACO*AbCO*1.66)
 	return
	end
c
c
	Subroutine G$HNO2(T,xsHNO2,AbHNO2,AmHNO2,THNO2,THNO2P)
C
	Double Precision NLosch
c	
	Common /Number/ NLosch
c
	AHNO2=xsHNO2*NLosch
	THNO2=exp(-AHNO2*AbHNO2*AmHNO2)
	THNO2P=exp(-AHNO2*AbHNO2*1.66)
 	return
	end
c
c
c
	Subroutine G$HNO3(T,xsHNO3,athno3,AbHNO3,AmHNO3,
     1 THNO3,THNO3P)
C
	Double Precision NLosch
c	
	Common /Number/ NLosch
c
	xnl=NLosch*1e-19
	AHNO3=xsHNO3*0.1*exp(athno3*1e-3*(T-298.))*xnl
	THNO3=exp(-AHNO3*AbHNO3*AmHNO3)
	THNO3P=exp(-AHNO3*AbHNO3*1.66)
 	return
	end
c
c
	Subroutine G$NO(ANO,AbNO,AmNO,TNO,TNOP)
C
	TNO=exp(-ANO*AbNO*AmNO)
	TNOP=exp(-ANO*AbNO*1.66)
 	return
	end
c
c
	Subroutine G$NO2(T,xsNO2,atno2,AbNO2,AmNO2,TNO2,TNO2P)
C
	Double Precision NLosch
c	
	Common /Number/ NLosch
c
	ANO2=(xsNO2+atno2*(T-220.))*NLosch
	TNO2=exp(-ANO2*AbNO2*AmNO2)
	TNO2P=exp(-ANO2*AbNO2*1.66)
 	return
	end
c
c
	Subroutine G$NO3(T,xsNO3,atno3,AbNO3,AmNO3,TNO3,TNO3P)
C
	Double Precision NLosch
c	
	Common /Number/ NLosch
c
	ANO3=(xsNO3+atno3*(T-230.))*NLosch
	TNO3=exp(-ANO3*AbNO3*AmNO3)
	TNO3P=exp(-ANO3*AbNO3*1.66)
 	return
	end
c
c
	Subroutine G$O3U(Tref,T,xs,a0o3,a1o3,Abo3,Amo3,tauz3,TO3,xso3,AO3)
C
	DOUBLE PRECISION AO3,TO3,xcheck,tauz3, NLosch
c	
	Common /Number/ NLosch
c
	fto3=1.-T/Tref
	xso3=xs*(1.+a0o3*fto3)/(1.+a1o3*fto3)
 	AO3=NLosch*xso3
	TAUZ3=AbO3*AO3
	XCHECK=AMO3*TAUZ3
	TO3=0.
	IF(XCHECK.le.99.)TO3=EXP(-XCHECK)
	return
	end
c	
c
	Subroutine G$SO2U(T,xsSO2,atso2,AbSO2,AmSO2,TSO2,TSO2P)
C
	Double Precision NLosch
c	
	Common /Number/ NLosch
c
c	UV band
c
	ASO2=(xsSO2+atso2*(T-213.))*NLosch
	TSO2=exp(-ASO2*AbSO2*AmSO2)
	TSO2P=exp(-ASO2*AbSO2*1.66)
 	return
	end
c
C
	Subroutine G$SO2I(ASO2,AbSO2,AmSO2,TSO2,TSO2P)
c
c	IR band
c
	TSO2=exp(-(ASO2*AbSO2*AmSO2))
	TSO2P=exp(-(ASO2*AbSO2*1.66))
 	return
	end
c
c
	Subroutine Interp (IntTyp,X1,X2,X,Y1,Y2,Y)
c
C	Interpolation routine using either a linear interpolation 
C	(IntTyp=1) or logarithmic interpolation (IntTyp=2)
C	The log interpolation returns to a linear interpolation if the
C	gradient is very small
C
	it=IntTyp
	If(y1.le.1e-5.or.y2.le.1e-5)it=1
	If(it.eq.1)goto 1
c
c	Log interpolation
c
	a1=log(y1)
	a2=log(y2)
	Grad=(a2-a1)/(x2-x1)
	If(Abs(Grad).le.1E-2)goto 1
	a=a1+(x-x1)*Grad
	y=exp(a)
	Return
C	
C	Linear interpolation
c
 1	continue
	y=y1+(x-x1)*(y2-y1)/(x2-x1)
	Return
	End
C
c
c
	Subroutine Lagrge (X4,X3,X2,X1,P,XM)
c
C	Interpolation routine using a 4 pt. LAGRANGE scheme
C
	WM=P*(P-1)*(P-2)
	W0=3.*(P**2-1)*(P-2)
	W1=3.*P*(P+1)*(P-2)
	W2=P*(P**2-1)
c
	XM=(W2*X4-W1*X3+W0*X2-WM*X1)/6.
	Return
	End
c
c	
	Function Nday(Year,Month,Day)
c
c	To obtain the calendar day (Day of year) from (Month, Day of month)
c
	Integer Day,Year
c
	Leap1=Mod(Year,4)
	leap2=Mod(year,100)
	leap3=Mod(year,400)
	leap=leap1-leap2+leap3
	Xdm=32.8
	If(Month.le.2)Xdm=30.6
	If(Leap.eq.0.and.Month.gt.2)Xdm=31.8
	Cday=Int(30.6*Month + Day - Xdm + 0.5)
	Nday=Ifix(Cday)
	Return
	End
c
c
c
	Subroutine Phase1(Wvl,RH,ja,IRH0,NN,IWV0,Inter1,Inter2)
c
c	Determines if interpolation in wavelength and/or humidity is
c	necessary for the phase functions of the four Shettle & Fenn 
c	aerosol models.
c
	Real Wvlref(5),RHref(4)
	
	Data Wvlref /.3,.55,.694,1.06,1.536/
	Data RHref /0.,70.,80.,99./
c
c	Determine the boundary humidity indices
c
	Do 10 IRH=1,3
	If(RH.lt.99.)goto 11
	IRH0=4
	IRH1=4
	goto 10
 11	continue
 	if(RH.ne.RHref(irh))goto 12
	IRH0=irh
	IRH1=irh
	goto 10
 12	If(RH.lt.RHref(irh).or.RH.gt.RHref(irh+1))goto 10
 	IRH0=irh
	IRH1=irh+1
 10	continue
c
c	Determine the boundary wavelength indices
c
	Do 20 IWL=1,4
	If(Wvl.gt.0.3)goto 21
	IWV0=1
	IWV1=1
	goto 20
 21	continue
 	If(Wvl.lt.1.536)goto 22
	IWV0=5
	Iwv1=5
	goto 20
 22	continue
 	If(Wvl.ne.Wvlref(iwl))goto 23
	IWV0=iwl
	IWV1=iwl
	goto 20
 23	continue
 	If(Wvl.lt.Wvlref(iwl).or.Wvl.gt.Wvlref(iwl+1))goto 20
	IWV0=iwl
	IWV1=iwl+1
 20	continue
c
c	Determine the (aerosol type, humidity) combination to select the
c	appropriate phase function
c
	NN=4*(JA-1)+IRH0
	Inter1=0
	Inter2=0
	If(IWV1.ne.IWV0)Inter2=1
	If(IRH1.ne.IRH0)Inter1=1
	If(IWV1.eq.IWV0.or.IRH1.eq.IRH0)goto 32
	Inter1=1
	Inter2=1
 32	continue
	Return
	End
c
c
c
	Subroutine Phase2(wvl0,ja,a0,a1,a2,A3,B0,B1,B2)
c
c	Calculates the spectral coefficients for the SRA aerosols, based 
c	on fits of Putsay's data. These phase functions are normalized to
c	1.0.
c
	REAL C01(6),C02(6),C03(6),C11(6),C12(6),C13(6)
	REAL C21(6),C22(6),C23(6),C31(6),C32(6),C33(6)
	REAL D01(6),D11(6),D21(6),D02(6),D12(6),D22(6)
	REAL D03(6),D13(6),D23(6)
c
	DATA C01 /4.1983,-4.5782,1.8095,.023009,-1.4302,.81463/
	DATA C02 /.84772,.19722,-.26051,.13604,-1.4856,.85833/
	DATA C03 /5.3667,-2.6223,.36658,0.,.024301,0./
	DATA C11 /-6.3223,6.8886,-1.5299,.19363,-1.2267,.63892/
	DATA C12 /-.045872,-4.8712,3.927,-.49406,-1.2365,.70588/
	DATA C13 /-1.9614,.24074,1.5583,-.34084,-.053584,.45265/
	DATA C21 /3.7043,-5.0188,1.2353,-.13367,-1.1047,.53007/
	DATA C22 /-.13977,3.3633,-3.1214,.48134,-1.1779,.62786/
	DATA C23 /-1.3035,3.7942,-3.9983,.61291,-1.5559,2.0313/
	DATA C31 /-.74424,1.1329,-.29929,.020114,-1.0218,.48272/
	DATA C32 /-6.0261E-4,-.70206,.75497,-.16314,-.87101,.36801/
	DATA C33 /.37894,-1.1823,1.2189,-.24736,-2.5674,3.1382/
	DATA D01 /-5.0313,60.924,377.11,-.56641,-10.092,35.529/
	DATA D11 /-179.83,299.04,-171.04,31.246,-3.9319,18.244/
	DATA D21 /120.84,-320.92,182.49,-33.577,-3.4496,12.734/
	DATA D02 /787.06,267.02,531.65,0.,490.27,0./
	DATA D12 /-16.651,26.858,-16.459,3.4092,-3.8694,14.497/
	DATA D22 /11.956,-31.224,16.935,-3.598,-3.4317,10.448/
	DATA D03 /4184.9,92707.,-26720.,2893.,-254.94,4683.5/
	DATA D13 /-3236.7,6653.4,-4421.3,927.19,-8.8844,208.63/
	DATA D23 /258.04,-852.99,647.57,-144.5,-6.9472,31.93/
c	
	WVL=MIN(2.5,WVL0)
	WVL2=WVL*WVL
	WVL3=WVL2*WVL
c	
	IF(JA.NE.5)GOTO 11
	A0=(C01(1)+C01(2)*WVL+C01(3)*WVL2+C01(4)*WVL3)/(1.+C01(5)*WVL+
     2  C01(6)*WVL2)
	A1=(C11(1)+C11(2)*WVL+C11(3)*WVL2+C11(4)*WVL3)/(1.+C11(5)*WVL+
     2  C11(6)*WVL2)
	A2=(C21(1)+C21(2)*WVL+C21(3)*WVL2+C21(4)*WVL3)/(1.+C21(5)*WVL+
     2  C21(6)*WVL2)
	A3=(C31(1)+C31(2)*WVL+C31(3)*WVL2+C31(4)*WVL3)/(1.+C31(5)*WVL+
     2  C31(6)*WVL2)
	B0=(D01(1)+D01(2)*WVL+D01(3)*WVL2+D01(4)*WVL3)/(1.+D01(5)*WVL+
     2  D01(6)*WVL2)
	B1=(D11(1)+D11(2)*WVL+D11(3)*WVL2+D11(4)*WVL3)/(1.+D11(5)*WVL+
     2  D11(6)*WVL2)
	B2=(D21(1)+D21(2)*WVL+D21(3)*WVL2+D21(4)*WVL3)/(1.+D21(5)*WVL+
     2  D21(6)*WVL2)
	GOTO 19
 11	IF(JA.NE.6)GOTO 12
 	A0=(C02(1)+C02(2)*WVL+C02(3)*WVL2+C02(4)*WVL3)/(1.+C02(5)*WVL+
     2  C02(6)*WVL2)
	A1=(C12(1)+C12(2)*WVL+C12(3)*WVL2+C12(4)*WVL3)/(1.+C12(5)*WVL+
     2  C12(6)*WVL2)
	A2=(C22(1)+C22(2)*WVL+C22(3)*WVL2+C22(4)*WVL3)/(1.+C22(5)*WVL+
     2  C22(6)*WVL2)
	A3=(C32(1)+C32(2)*WVL+C32(3)*WVL2+C32(4)*WVL3)/(1.+C32(5)*WVL+
     2  C32(6)*WVL2)
	B0=(D02(1)+D02(2)*WVL+D02(3)*WVL2+D02(4)*WVL3)/(1.+D02(5)*WVL+
     2  D02(6)*WVL2)
	B1=(D12(1)+D12(2)*WVL+D12(3)*WVL2+D12(4)*WVL3)/(1.+D12(5)*WVL+
     2  D12(6)*WVL2)
     	B2=(D22(1)+D22(2)*WVL+D22(3)*WVL2+D22(4)*WVL3)/(1.+D22(5)*WVL+
     2  D22(6)*WVL2)
	GOTO 19
 12	IF(JA.NE.7)GOTO 19
 	A0=(C03(1)+C03(2)*WVL+C03(3)*WVL2+C03(4)*WVL3)/(1.+C03(5)*WVL+
     2  C03(6)*WVL2)
	A1=(C13(1)+C13(2)*WVL+C13(3)*WVL2+C13(4)*WVL3)/(1.+C13(5)*WVL+
     2  C13(6)*WVL2)
	A2=(C23(1)+C23(2)*WVL+C23(3)*WVL2+C23(4)*WVL3)/(1.+C23(5)*WVL+
     2  C23(6)*WVL2)
	A3=(C33(1)+C33(2)*WVL+C33(3)*WVL2+C33(4)*WVL3)/(1.+C33(5)*WVL+
     2  C33(6)*WVL2)
	B0=(D03(1)+D03(2)*WVL+D03(3)*WVL2+D03(4)*WVL3)/(1.+D03(5)*WVL+
     2  D03(6)*WVL2)
	B1=(D13(1)+D13(2)*WVL+D13(3)*WVL2+D13(4)*WVL3)/(1.+D13(5)*WVL+
     2  D13(6)*WVL2)
	B2=(D23(1)+D23(2)*WVL+D23(3)*WVL2+D23(4)*WVL3)/(1.+D23(5)*WVL+
     2  D23(6)*WVL2)
 19	CONTINUE
 	Return
	End
c
c
c
	BLOCK DATA PhData
c
c	Contains all the data to calculate the phase functions
c	(normalized to 1.0) of the Shettle & Fenn aerosols.
c 	MnPhFn is a large look-up table to select the index for the
c	appropriate phase function to be used. These have been fitted as
c	a function of scattering angle from the MODTRAN2 block data.
c	They are then interpolated in wavelength and/or humidity in 
c	subroutine PHASE1.
c
	Common /MnPhFn/ Mum1(5),Mum2(5),Mum3(5),Mum4(5),
     2   		    Mum5(5),Mum6(5),Mum7(5),Mum8(5),
     3		    Mum9(5),Mum10(5),Mum11(5),Mum12(5),
     4		    Mum13(5),Mum14(5),Mum15(5),Mum16(5)
     	Common /COEF/ coef1(4),coef2(4),coef3(4),coef4(4),coef5(4),
     2  coef6(4),coef7(4),coef8(4),coef9(4),coef10(4),coef11(4),
     3  coef12(4),coef13(4),coef14(4),coef15(4),coef16(4),coef17(4),
     4  coef18(4),coef19(4),coef20(4),coef21(4),coef22(4),coef23(4),
     5  coef24(4),coef25(4),coef26(4)
	
     	Data Mum1 /3,2,2,2,4/
	Data Mum2 /3,2,2,2,4/
	Data Mum3 /3,3,3,13,4/
	Data Mum4 /21,23,23,23,24/
	Data Mum5 /11,12,13,13,4/
	Data Mum6 /1,12,12,13,4/
	Data Mum7 /1,12,12,13,4/
	Data Mum8 /21,23,23,23,23/
	Data Mum9 /7,7,7,14,14/
	Data Mum10 /22,7,8,8,15/
	Data Mum11 /5,9,9,9,10/
	Data Mum12 /20,26,26,26,25/
	Data Mum13 /11,17,17,18,18/
	Data Mum14 /11,17,17,17,18/
	Data Mum15 /16,19,19,17,18/
	Data Mum16 /15,16,16,19,19/
	Data coef1 /75.076,15.489,-.63666,13.223/
	Data coef2 /14.112,-1.5781,.11803,1.2411/
	Data coef3 /31.334,.078401,.15612,4.8454/
	Data coef4 /13.636,-1.9645,.10512,.3839/
	Data coef5 /232.3,-48.726,3.135,4.8947/
	Data coef6 /286.85,-63.482,3.9161,3.8698/
	Data coef7 /15.367,-1.8062,.091857,.49924/
	Data coef8 /8.9154,-1.2369,.055255,.05388/
	Data coef9 /41.211,-6.5633,.35612,.75109/
	Data coef10 /7.991,-.91351,.03869,.070524/
	Data coef11 /1.525,678.18,-29.405,428.76/
	Data coef12 /26.742,-2.6073,.23645,2.5487/
	Data coef13 /16.769,-2.4267,.15085,.84414/
	Data coef14 /3.3641,-.37048,.013674,-.013413/
	Data coef15 /4.1232,-.5204,.021062,-.025236/
	Data coef16 /1.993,17273.,-809.84,8574.4/
	Data coef17 /.79497,.080383,-.002775,.09951/
	Data coef18 /.72947,.47274,-.012227,.62264/
	Data coef19 /1.1549,.23963,-.0088949,.204/
	Data coef20 /1698.,-425.03,28.967,30.9/
	Data coef21 /525.35,131.03,-9.2447,67.011/
	Data coef22 /56.571,-8.8617,.48769,1.3827/
	Data coef23 /101.15,-11.792,1.0288,7.0975/
	Data coef24 /48.028,-8.692,.5231,1.0421/
	Data coef25 /37.104,-5.8167,.31294,.56116/
	Data coef26 /256.51,-62.645,4.4611,3.2847/
	End
c
c
c
	Function PhF1 (model,iwv,xs)
c
c	Selects the proper phase function for the Shettle & Fenn aerosols
c
c	Stores the coefficients for 26 phase functions for the Shettle & 
c	Fenn aerosols.
c	(Note that only 26 functions are used from a total of 70 available
c	functions in MODTRAN2; all these functions are normalized to 1) 
c	These functions have been fitted to the data in MODTRAN2,
c	so that they are now continuous functions of the scattering angle,
c	xs, for xs<10 deg.	
c
	Real C(4)
	Common /MnPhFn/ Mnum(5,16)
	Common /COEF/ Coeff(4,26)
c
	M=Mnum(iwv,model)
	Do 1 I=1,4
	C(I)=Coeff(I,M)
 1	continue
	PhF1=(C(1)+C(2)*xs+C(3)*xs*xs)/(1.+C(4)*xs)
	Return
	End
C
C
	Subroutine ScanG(step,FWHM,fk,sigma2,N)
c
c	Smoothes irradiance with a Gaussian filter
c
	Real wv(2002),ET(2002),limit1,limit2
	DOUBLE PRECISION TB,TG,TT,TX
	DOUBLE PRECISION BNORM(2002),GLOBH(2002),GLOBT(2002),DIRX(2002)
	COMMON /SOLAR1/ WV,WvLMN,WvLMX,WV1,WV2
	COMMON /SOLAR2/ BNORM,GLOBH,GLOBT,DIRX,ET
c
	if(wv1.gt.wvlmn+fwhm)goto 10
	if(wv1.gt.wvlmn+.5*fwhm)goto 11
	write(18,100)
 100	format(' *** ERROR *** Lower limit for scans needs to be > WV1 ',
     1 '+ 0.5*FWHM!',/)
     	goto 999
 11	write(18,101)
 101	format(' * WARNING * Lower limit for scans is not > WV1 + ',
     1 'FWHM.',/,' This will reduce accuracy in the results for',
     2 ' the first wavelengths.',/)
 10	continue
 	if(wv2.lt.wvlmx-fwhm)goto 20
	if(wv2.lt.wvlmx-.5*fwhm)goto 21
	write(18,102)
 102	format(' *** ERROR *** Upper limit for scans needs to be < WV2 ',
     1 '- 0.5*FWHM!',/)
     	goto 999
 21	write(18,103)
 103	format(' * WARNING * Upper limit for scans is not < WV2 - ',
     1 'FWHM.',/,' This will reduce accuracy in the results for',
     2 ' the last wavelengths.',/)
 20	continue
c
c	Find the limits for spectral integration
c
	wvc=wv1
 40	continue
	dw1=1.
	d1=aint(wvc-fk)
	if(d1.le.400.)dw1=0.5
	if(d1.gt.1705)dw1=5.
	limit1=d1-dw1
	dw2=1.
	d2=aint(wvc+fk+1.)
	if(d2.le.400.)dw2=0.5
	if(d2.gt.1705)dw2=5.
	limit2=d2+dw2
	Nw=int((limit2-limit1)/dw1)+1
c
	do 30 j=1,N
	 if(wv(j).ne.limit1)goto 30
	 index=j
 30	continue
c
	T0=0.
	TB=0.
	TG=0.
	TT=0.
	TX=0.
	Totwi=0.
c
c	Perform integration & convolution
c		
	do 32 k=1,Nw
	kx=index+k-1
	wvx=wv(kx)
	dw=1.
	if(wvx.lt.400.)dw=0.5
	if(wvx.eq.400.)dw=0.75
	if(wvx.gt.1705)dw=5.
	if(wvx.eq.1700.)dw=1.75
	if(wvx.eq.1702.)dw=2.5
	if(wvx.eq.1705.)dw=3.75
	wt=exp(-(wvc-wvx)*(wvc-wvx)/2./sigma2)
	T0=T0+ET(kx)*wt*dw
	TB=TB+Bnorm(kx)*wt*dw
	TG=TG+Globh(kx)*wt*dw
	TT=TT+Globt(kx)*wt*dw
	TX=TX+Dirx(kx)*wt*dw
	Totwi=Totwi+wt*dw
 32	continue
 	TB=TB/Totwi
	TG=TG/Totwi
	TT=TT/Totwi
	T0=T0/Totwi
	TX=TX/Totwi
c	
	write(18,200)wvc,T0,TB,TX,TG,TT
 200	FORMAT(3x,f6.1,2X,5(E10.4,2X))
 	wvc=wvc+step
	if(wvc.le.wv2)goto 40
 999	return
	end
c
c	
	Subroutine ScanT(step,FWHM,fk,N)
c
c	Smoothes irradiance with a filter with 'triangular-shape' transmittance 
c
	Real wv(2002),ET(2002),limit1,limit2
	DOUBLE PRECISION TB,TG,TT,TX
	DOUBLE PRECISION BNORM(2002),GLOBH(2002),GLOBT(2002),DIRX(2002)
	COMMON /SOLAR1/ WV,WvLMN,WvLMX,WV1,WV2
	COMMON /SOLAR2/ BNORM,GLOBH,GLOBT,DIRX,ET
c
	if(wv1.gt.wvlmn+fwhm)goto 10
	if(wv1.gt.wvlmn+.5*fwhm)goto 11
	write(18,100)
 100	format(' *** ERROR *** Lower limit for scans needs to be > WV1 ',
     1 '+ 0.5*FWHM!',/)
     	goto 999
 11	write(18,101)
 101	format(' * WARNING * Lower limit for scans is not > WV1 + ',
     1 'FWHM.',/,' This reduces accuracy in the results for',
     2 ' the first wavelengths.',/)
 10	continue
 	if(wv2.lt.wvlmx-fwhm)goto 20
	if(wv2.lt.wvlmx-.5*fwhm)goto 21
	write(18,102)
 102	format(' *** ERROR *** Upper limit for scans needs to be < WV2 ',
     1 '- 0.5*FWHM!',/)
     	goto 999
 21	write(18,103)
 103	format(' * WARNING * Upper limit for scans is not < WV2 - ',
     1 'FWHM.',/,' This reduces accuracy in the results for',
     2 ' the last wavelengths.',/)
 20	continue
c
c	Find the limits for spectral integration
c

	wvc=wv1
 40	continue
	dw1=1.
	d1=aint(wvc-fk+.5)
	if(d1.le.400.)dw1=0.5
	if(d1.gt.1705)dw1=5.
	limit1=d1-dw1
	dw2=1.
	d2=aint(wvc+fk+.5)
	if(d2.le.400.)dw2=0.5
	if(d2.gt.1705)dw2=5.
	limit2=d2+dw2
	Nw=int((limit2-limit1)/dw1)+1
c
	do 30 j=1,N
	 if(wv(j).ne.limit1)goto 30
	 index=j
 30	continue
c
	T0=0.
	TB=0.
	TG=0.
	TT=0.
	TX=0.
	Totwi=0.
c
c	Perform integration & convolution
c		
	do 32 k=1,Nw
	kx=index+k-1
	wvx=wv(kx)
	dw=1.
	if(wvx.lt.400.)dw=0.5
	if(wvx.eq.400.)dw=0.75
	if(wvx.gt.1705)dw=5.
	if(wvx.eq.1700.)dw=1.75
	if(wvx.eq.1702.)dw=2.5
	if(wvx.eq.1705.)dw=3.75
	wt=Max(0.,1.-abs(wvc-wvx)/fwhm)
 	T0=T0+ET(kx)*wt*dw
	TB=TB+Bnorm(kx)*wt*dw
	TG=TG+Globh(kx)*wt*dw
	TT=TT+Globt(kx)*wt*dw
	TX=TX+Dirx(kx)*wt*dw
	Totwi=Totwi+wt*dw
 32	continue
 	TB=TB/Totwi
	TG=TG/Totwi
	TT=TT/Totwi
	T0=T0/Totwi
	TX=TX/Totwi
c	
	write(18,200)wvc,T0,TB,TX,TG,TT
 200	FORMAT(3x,f6.1,2X,5(E10.4,2X))
 	wvc=wvc+step
	if(wvc.le.wv2)goto 40
 999	return
	end
C
C
	SUBROUTINE STEPS (WVLN,WLMN,WLMX,DWVL)
C
	DWVL=1.0
	IF(wvln.lt.400.)DWVL=0.5
	IF(wvln.eq.400.)DWVL=0.75
	IF(wvln.EQ.1700.)DWVL=1.75
	IF(wvln.EQ.1702.)DWVL=2.5
	IF(wvln.EQ.1705.)DWVL=3.75
	IF(wvln.GE.1706.)DWVL=5.
	IF(wvln.EQ.WLMN.or.wvln.EQ.WLMX)DWVL=DWVL/2.
 	RETURN
	END
C
C
C
      Subroutine SunPSA(dHour,dLat,dLong,decli,
     1 Zenith,Azimu,Julian,R,EOT,P,T,Year,Month,Day)
c
c	'PSA Algorithm' by Blanco-Muriel et al. (Solar Energy 2001)
c	Translated to Fortran from their original code in C++
c
c***	Inputs  ***
c
c	Year
c	Month
c	Day
c	dHour: decimal Hour (Universal Time, UT)
c	dLat: decimal Latitude (deg., positive North)
c	dLong: decimal Longitude (deg., positive East)
c
 	Integer Year,Day
 	Double Precision Julian,pi,twopi,rad,LMST,GMST,dRLat,HourAngl,
     1 cosHA,Elapsd,dX,dY,EclipL,Paralx,Decli,dLong,dLat,AUnit,Radius,
     2 EclipO,RightA,Anomly,Omega,sinELg,SunLng,zenith,azimu,cosLat,
     3 sinLat
c
c
c	 Declaration of some constants
c
 	pi=3.14159265358979323846
 	twopi=2*pi
 	rad=pi/180
 	Radius=6371.01
 	AUnit=149597890.0
c
c	Calculate current Julian Day
c
 	liAux1 =(Month-14)/12
  	LiAux2=(1461*(Year + 4800 + liAux1))/4 
     1 + (367*(Month- 2-12*liAux1))/12
     2 - (3*((Year + 4900+ liAux1)/100))/4+Day-32075
      Julian=Float(LiAux2)-0.5+dHour/24.
c
c	Calculate difference in days between the current Julian Day 
c	and JD 2451545.0, which is noon 1 January 2000 Universal Time 
c
  	Elapsd = Julian-2451545.0
c 
c	Calculate ecliptic coordinates (ecliptic longitude and obliquity of the 
c	ecliptic in radians) but without limiting the angle to be less than 2*Pi 
c	(i.e., the result may be greater than 2*Pi)
c
  	Omega=2.1429-0.0010394594*Elapsd
  	SunLng = 4.8950630+ 0.017202791698*Elapsd
  	Anomly = 6.2400600+ 0.0172019699*Elapsd
  	EclipL = SunLng + 0.03341607*sin(Anomly) + 0.00034894*
     1 sin(2.*Anomly)-0.0001134-0.0000203*sin(Omega)
  	EclipO = 0.4090928 - 6.2140e-9*Elapsd+0.0000396*cos(Omega)
c 
c	Calculate celestial coordinates (right ascension and declination) in radians 
c	but without limiting the angle to be less than 2*Pi (i.e., the result may be 
c	greater than 2*Pi)
c
  	SinELg= sin(EclipL)
  	dY = cos(EclipO) * SinELg
  	dX = cos(EclipL)
  	RightA = atan2(dY,dX)
  	if(RightA.lt.0.0) RightA = RightA + twopi
  	Decli = asin(sin(EclipO)*SinELg)
c 
c	Calculate local coordinates (azimuth and zenith angle) in degrees
c		
  	GMST = 6.6974243242 + 0.0657098283*Elapsd + dHour
  	LMST = (GMST*15. + dLong)*rad
  	HourAngl = LMST - RightA
  	dRLat = dLat*rad
  	cosLat = cos(dRLat)
  	sinLat = sin(dRLat)
  	cosHA= cos(HourAngl)
  	Zenith = acos(cosLat*cosHA*cos(Decli) + sin(Decli)*sinLat)
  	dY = -sin(HourAngl)
  	dX = tan(Decli)*cosLat - sinLat*cosHA
  	Azimu = atan2(dY, dX)
  	if (Azimu.lt. 0.0)Azimu = Azimu + twopi
  	Azimu = Azimu/rad
c
c	Parallax Correction
c
  	Paralx=(Radius/AUnit)*sin(Zenith)
  	Zenith=(Zenith + Paralx)/rad
c
c	Sun-Earth actual distance in AU (from Michalsky's paper)
c
	R=1.00014-.01671*cos(Anomly)-.00014*cos(2.*Anomly)
c
c	Equation of Time (in min, from Michalsky's paper)
c
	RightA=RightA/rad
	SunLng=SunLng/rad
	xsun=-aint(abs(SunLng)/360.)
	if(Sunlng.lt.0.)xsun=-xsun+1.
	SunLng=SunLng+xsun*360.
	EOT=(SunLng-RightA)*4.
C
C	REFRACTION CORRECTION FOR ACTUAL ATMOSPHERIC CONDITIONS (P,T)
C
	ELD=90.-Zenith
	ELD2=ELD*ELD
	REFR=0.
	PT=P/T
	IF(ELD.LT.15.0.AND.ELD.GE.-2.5)REFR=PT*(.1594+.0196*ELD+
     # 2E-5*ELD2)/(1.+.505*ELD+.0845*ELD2)
     	IF(ELD.GE.15.0.AND.ELD.LT.90.)REFR=.00452*PT/TAN(ELD*rad)
	Zenith=90.-(ELD+REFR)
c
c	Declination in degrees
c
	Decli=Decli/rad
 	return
 	end
C
C
C
	SUBROUTINE UVDAT(ERY0,ERY1,ERY2,ERY3,ERY4,DNA,PHO,ECAL,ACG,
     % POL,SIS,PRT,SCUPH,SCUPM,wvln)
C
C	Calculates different erythema and DNA action/damage curves
C
	REAL A(6),B(6)
	DATA B/-1.3448,1.2203E4,5.2729E5,-1.33E7,7.4736E7,54.81/
	DATA A/41.791,1.3853E4,3.6663E5,-1.1993E7,7.5816E7,53.426/
C
	DW=wvln-300.
	DW2=DW*DW
	DW3=DW*DW2
	DW4=DW*DW3
	DW5=DW*DW4
	DW6=DW*DW5
	DW7=DW*DW6
	DW8=DW*DW7
	DW325=wvln-325.
	wvl=wvln/1000.
	XL=-log(wvl)
	XL2=XL*XL
	XL3=XL*XL2
	XL4=XL2*XL2
C
C	ERYTHEMA SPECTRUM OF CIE 1987 (MCKINLAY & DIFFEY)
C
	ERY0=1.0
	IF(wvln.GE.299.0.AND.wvln.Lt.329.)ERY0=10.**(.094*(298.-wvln))
	IF(wvln.GE.329.)ERY0=10.**(.015*(139.-wvln))
C
C	ERYTHEMA SPECTRUM OF KOMHYR AND MACHTA, fitted by GREEN ET AL.
C		(1974)
C
	EXPL=EXP((DW+3.5)/2.692)
	ERY1=.04485/(1.+EXP((DW-11.4)/3.13))+3.9796*EXPL/(1.+EXPL)**2
C
C	ERYTHEMA SPECTRUM OF COBLENTZ AND STAIR (1934), fitted by
C		GREEN ET AL. (1975)
C
	EXPL2=EXP((DW+3.)/3.21)
	ERY2=0.
	IF(wvln.LE.325.)ERY2=4.*EXPL2/(1.+EXPL2)**2
C
C	ERYTHEMA SPECTRUM OF PARRISH ET AL. (1982), AS FITTED BY
C		BJORN (1989)
C
	ERY3=EXP(-.4232-.1413*DW-.0105*DW2+2E-4*DW3+8.982E-6*DW4-
     # 3.921E-7*DW5+5.623E-9*DW6-3.603E-11*DW7+8.759E-14*DW8)
C
C	ERYTHEMA SPECTRUM OF DIFFEY (1982) MODIFIED BY BJORN (1989)
C
	ERY4=0.
	IF(wvln.GE.326.0.OR.wvln.LE.284.)GOTO 90
	ERY4=.98-.0957*DW
	IF(wvln.gt.310.)ERY4=EXP(-5.0188-.118*DW325+9.382E-4*DW325*DW325)
 90	CONTINUE
C
C	PLANT/DNA SPECTRUM OF SETLOW (1974) AS FITTED BY
C		GREEN & MO (1975)
C
	DNA=0.
	IF(wvln.GE.366.)GOTO 99
	DNA=EXP(13.82*(-1.+1./(1.+EXP((wvln-310.)/9.))))
 99	CONTINUE
C
C	PHOTOSYNTHESIS INHIBITION SPECTRUM OF CALDWELL ET AL. (1986)
C
	PHO=0.
	IF(wvln.LE.340.)PHO=13.42*EXP(106.219-.6122*wvln
     1 +.0008316*wvln*wvln) 
C
C	CALDWELL (1971) BIOLOGICAL ACTION CURVE, AS FITTED BY 
C	GREEN ET AL. (1974)
C
	ECAL=0.
	IF(wvln.LE.313.)ECAL=2.618*(1.-(wvln/313.3)**2)*EXP(-DW/31.08)
C
C	ACGIH (1978) SAFETY SPECTRUM, AS FITTED BY WESTER (1981, 1984)
C
	ACG=0.
	IF(wvln.Lt.300.)ACG=1.-0.36*((wvln-270.)/20.)**1.64
	IF(wvln.GE.300.0.AND.wvln.LE.315.)ACG=0.3*0.74**DW
C
C	POLYCHROMATIC ACTION FOR HIGHER PLANTS,data fom Caldwell et al.
C	(1986); fit by Gueymard
C
	POL=EXP(40.355-106.88*XL+59.307*XL2)
C
C	SYSTEMATIC IMMUNOSUPPRESSION, data from deFabo et al. (1990);
C		fit by Gueymard
C	
	SIS=EXP(-42.826+45.056*XL-9.3345*XL2)
C
C	DNA TO PROTEIN CROSSLINKS, data from Peak & Peak (1986);
C		fit by Gueymard
C
	PRT=EXP(-1305.8+5287.4*XL-7917.5*XL2+5154.1*XL3-1228.3*XL4)
C
C	SKIN CARCINOGENESIS FOR MICE AND HUMANS, data from
C		de Gruijl & Van der Leun (1994); fit by Gueymard
C
	H=WVL-.299
	X=WVL-.293
	SH=0.
	SX=0.
	H1=1.
	X1=1.
	DO 10 I=1,5
	H1=H1*H
	X1=X1*X
	SH=SH+A(I)*H1
	SX=SX+B(I)*X1
 10	CONTINUE
	SCUPH=EXP(-SH/(1.+A(6)*H))
	SCUPM=EXP(-SX/(1.+B(6)*X))
C
 999	RETURN
	END
C
C*********************************************************************

